#ifndef CHAINED_VARIABLE_HEADER_INCLUDED
#define CHAINED_VARIABLE_HEADER_INCLUDED

#include <assert.h>

template <class VO>
class ChainedVariable
{
public:
	ChainedVariable()
	{
		Phead = Ptail = NULL ;
	}
	~ChainedVariable()
	{
		ChainedVariableStructure<VO> *Ptmp , *Ppre ;
		for( Ptmp=Phead ; Ptmp ; )
		{
			Ppre = Ptmp->Pnext ;
			free( Ptmp ) ;
			Ptmp = Ppre ;
		}
		Phead = Ptail = NULL ;
	}
	VO *Add( int key )
	{
		if( !Phead )
		{
			assert( !Ptail ) ;
			Phead = (ChainedVariableStructure<VO>*)malloc( sizeof(ChainedVariableStructure<VO>) ) ;
			if( !Phead )return NULL ;
			Ptail = Phead ;
			Phead->key = key ;
			Phead->Pnext = NULL ;
			Phead->Plast = NULL ;
			return &(Phead->body) ;
		}
		ChainedVariableStructure<VO> *Ptmp , *Ppre ;
		Ppre = Phead ;

		if( Ppre->key>key )
		{//擪ɒǉ
			assert( Ppre->Plast == NULL ) ;
			ChainedVariableStructure<VO> *Pnew ;
			Pnew = (ChainedVariableStructure<VO>*)malloc( sizeof(ChainedVariableStructure<VO>) ) ;
			if( !Pnew )return NULL ;
			Pnew->key = key ;
			Ppre->Plast = Pnew ;
			Pnew->Pnext = Ppre ;
			Pnew->Plast = NULL ;
			Phead = Pnew ;
			return &(Pnew->body) ;
		}

		for( Ptmp=Phead->Pnext ; Ptmp ; Ptmp=Ptmp->Pnext )
		{
			if( Ptmp->key>key )
			{//Ptmp̕L[傫̂PpreƂ̃XL}ɒǉ
				assert( Ppre->Pnext == Ptmp ) ;
				assert( Ptmp->Plast == Ppre ) ;
				ChainedVariableStructure<VO> *Pnew ;
				Pnew = (ChainedVariableStructure<VO>*)malloc( sizeof(ChainedVariableStructure<VO>) ) ;
				if( !Pnew )return NULL ;
				Pnew->key = key ;
				Ppre->Pnext = Pnew ;
				Ptmp->Plast = Pnew ;
				Pnew->Plast = Ppre ;
				Pnew->Pnext = Ptmp ;
				return &(Pnew->body) ;
			}
			Ppre = Ptmp ;
		}
		//炸ɍŌ܂ŗŌɒǉ
		ChainedVariableStructure<VO> *Pnew ;
		Pnew = (ChainedVariableStructure<VO>*)malloc( sizeof(ChainedVariableStructure<VO>) ) ;
		if( !Pnew )return NULL ;
		assert( Ppre->Pnext == NULL ) ;
		Pnew->key = key ;
		Ppre->Pnext = Pnew ;
		Pnew->Pnext = NULL ;
		Pnew->Plast = Ppre ;
		Ptail = Pnew ;
		return &(Pnew->body) ;
	}
	void DeleteWithKey( int key )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		Ptmp = SearchWithKey_i( order ) ;
		if( Ptmp )
			{ Delete( Ptmp ) ; }
	}
	void DeleteWithOrder( int order )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		Ptmp = SearchWithOrder_i( order ) ;
		if( Ptmp )
			{  Delete( Ptmp ) ; }
	}
	VO *SearchWithKey( int key )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		Ptmp = SearchWithKey_i( key ) ;
		if( Ptmp )
			{ return &(Ptmp->body) ; }
		return NULL ;
	}
	VO *SearchWithOrder( int order )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		Ptmp = SearchWithOrder_i( order ) ;
		if( Ptmp )
			{ return &(Ptmp->body) ; }
		return NULL ;
	}
	VO *operator[](int order)
	{
		return SearchWithOrder(order) ;
	}
private:
	template <class VOL>
	struct ChainedVariableStructure
	{
		VOL body ;
		int key ;
		struct ChainedVariableStructure<VOL> *Pnext ;
		struct ChainedVariableStructure<VOL> *Plast ;
	} ;
	struct ChainedVariableStructure<VO> *Phead ;
	struct ChainedVariableStructure<VO> *Ptail ;


	ChainedVariableStructure<VO> *SearchWithKey_i( int key )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		for( Ptmp=Phead ; Ptmp ; Ptmp=Ptmp->Pnext )
		{
			if( Ptmp->key == key )
			{
				return Ptmp ;
			}
		}
		return NULL ;
	}
	ChainedVariableStructure<VO> *SearchWithOrder_i( int order )
	{
		ChainedVariableStructure<VO> *Ptmp ;
		if( order<0 )return NULL ;
		for( Ptmp=Phead ; Ptmp ; Ptmp=Ptmp->Pnext )
		{
			if( order==0 )
			{
				return Ptmp ;
			}
			order-- ;
		}
		return NULL ;
	}


	void Delete( struct ChainedVariableStructure<VO> *Pdest )
	{
		struct ChainedVariableStructure<VO> *Pl , *Pn ;
		Pl = Pdest->Plast ;
		Pn = Pdest->Pnext ;

		if( Pl )
		{//O
			Pl->Pnext = Pn ;
		}
		else
		{//O擪
			assert( Phead == Pdest ) ;
			Phead = Pn ;
		}

		if( Pn )
		{//낪
			Pn->Plast = Pl ;
		}
		else
		{//낪擪
			assert( Ptail == Pdest ) ;
			Ptail = Pl ;
		}

		free( Pdest ) ;
	}
} ;


#endif /*CHAINED_VARIABLE_HEADER_INCLUDED*/