#include "../common.h"

void TaskModeManager::Finit()
{
	iPreMode = cMode_Invalid ;
	iMode = cMode_Param ;
	iRedrawChip = 0 ;
	GL::iCurRoom = 0 ;
	GL::iDrawMode = 0 ;
	LoadRoom() ;
	GL::pFODSW->GetViewPosition( &x , &y ) ;

	SetDrawOrderPandC( true , false ) ;
//			for( int i=0 ; i<FODS_MAX_OBJECT ; i++ )
//				GL::pFODSW->ObjUnit.Add( i , i+1 , i ) ;
//			for( int i=0 ; i<FODS_MAX_DOOR ; i++ )
//				GL::pFODSW->DoorUnit.Add( i , i+1 , i , 0 , 1, 2 ) ;
//			tstring strFileName( GL::strProjectPath );
//			strFileName += _T( "testout.fods" ) ;
//			GL::pFODSW->Save( strFileName.c_str() ) ;
}
void TaskModeManager::Fmain()
{

	if( KeyScroll( &iMode , KC_F2 , KC_F1 , 1 , 1 , cMode_Param ) )
	{
		InvalidateKey() ;
		GL::RequestRedraw() ;
	}
	if( iPreMode != iMode )
	{
		if( iMode == cMode_NLoop ){ iMode = cMode_PLoop-1 ; }
		if( iMode == cMode_PLoop ){ iMode = cMode_NLoop+1 ; }
		iPreMode = iMode ;

		this->KillP( TP_HIGHEST , TP_LOWEST ) ;

		switch( iMode )
		{
		case cMode_Param:
			new TaskModeParamater( this , true ) ;
		break ;
		case cMode_Map:
			new TaskModeMap( this , true ) ;
		break ;
		case cMode_Obj:
			new TaskModeObj( this , true ) ;
		break ;
		case cMode_Door:
			new TaskModeDoor( this , true ) ;
		break ;
		default:
			assert( 0 ) ;
		}

	}

	int iOperateMap = 0 ;

	switch( iMode )
	{
	case cMode_Param:
	case cMode_Map:
	case cMode_Obj:
	case cMode_Door:
		iOperateMap = 1 ;
	break ;
	default:
		assert( 0 ) ;
	}

	if( iOperateMap )
	{
		if( KeyPush( KC_TAB ) )
		{
			InvalidateKey() ;
			RotateCorrect( &++GL::iDrawMode , 4 ) ;
			if( GL::iDrawMode==1 ){ GL::iDrawMode++; }
			RequestRedrawChip() ;
		}
		if( KeyScroll( &x , KC_W , KC_Q , 64 , 8 , 0 ) )
			{ GL::RequestRedraw() ; InvalidateKey() ; }
		if( KeyScroll( &y , KC_X , KC_S , 64 , 8 , 0 ) )
			{ GL::RequestRedraw() ; InvalidateKey() ; }
		if( KeyPush( KC_F5 ) )
		{
			InvalidateKey() ;
			GL::iUpdatedRoom = 0 ;
			tstring strFilename = GL::GetFODSFileName( GL::iCurRoom ) ;
			if( !GL::pFODSW->Save( strFilename.c_str() ) )
			{
				new TaskObjectBoxText( this , false , 0 , 0 , 16 , 8 , RGB(0,0,0) , RGB(255,255,255) ,
					_T("Room has been saved") , 120 ) ;
			}
			else
			{
				new TaskObjectBoxText( this , false , 0 , 0 , 16 , 8 , RGB(0,0,0) , RGB(255,255,255) ,
					_T("Failed to save the room") , 180 ) ;
			}
		}
		int iTmp=0 ;
		if( KeyScroll( &iTmp , KC_F4 , KC_F3 , 1 , 16 , 0 ) )
		{
			if( !GL::iUpdatedRoom || KeyOn( KC_CTRL ) )
			{
				InvalidateKey() ;
				GL::iCurRoom += iTmp ;
				RotateCorrect( &GL::iCurRoom , FODS_MAX_ROOM ) ;
				GL::iUpdatedRoom = 0 ;
				LoadRoom() ;
				GL::RequestRedraw() ;
			}
			else
			{
				new TaskObjectBoxText( this , false , 0 , 0 , 32 , 16 , RGB(0,0,0) , RGB(255,255,255) ,
					_T("To change room without saving changes:\nHold down CTRL key while switching") , 150 ) ;
			}
		}
	}
	if( iRedrawChr )
	{
		iRedrawChr = 0 ;
		GL::pFODSW->DrawChr() ;
	}
	if( iRedrawChip )
	{
		iRedrawChip = 0 ;
		GL::pFODSW->DrawChip( GL::iDrawMode ) ;
		GL::RequestRedraw() ;
	}
	if( KeyPush( KC_F11 ) )
	{
		if( GL::Compile() )
		{
			tostringstream  TOSS ;
			TOSS << _T("Successfully compiled\nProject folder(") << 
				GL::strProjectPath.c_str() << _T(")\n") << 
				GL::FILE_PATH_OUT_NES << _T("ROM saved") ;
			new TaskObjectBoxText( this , false , 0 , 0 , 16 , 8 , RGB(230,250,255) , RGB(0,64,255) , 
				TOSS.str().c_str() , 120 ) ;
		}
		else
		{
			tostringstream  TOSS ;
			TOSS << _T("Failed to compile\nProject folder(") << 
				GL::strProjectPath.c_str() << _T(")\n") << 
				GL::FILE_PATH_OUTPUT << _T("And") << GL::FILE_PATH_OUTPUT_SENV << _T("\nPlease solve the problem") ;
			new TaskObjectBoxText( this , false , 0 , 0 , 16 , 8 , RGB(255,230,230) , RGB(210,64,32) , 
				TOSS.str().c_str() , 180 ) ;
		}
	}
}
void TaskModeManager::Fdest()
{
	
}
void TaskModeManager::Fdraw()
{
	GL::pFODSW->SetViewPosition( x , y ) ;
	GL::pFODSW->DrawRoom( GL::SFC_BACK ) ;
//	GL::mdo.Blt( MDO3WINAPI , GL::SFC_BACK , 0 , 0 , 128 , 128 , GL::SFC_CHAR , 0 , 0 ) ;
//	GL::mdo.Blt( MDO3WINAPI , GL::SFC_BACK , 0 , 128 , 256 , 256 , GL::SFC_CHIP , 0 , 0 ) ;
}

void TaskModeManager::LoadRoom()
{
	GL::LoadRoom( GL::pFODSW , GL::iCurRoom ) ;
	GL::pFODSW->DrawChr() ;
	GL::pFODSW->DrawChip( GL::iDrawMode ) ;
	GL::pFODSW->pVTE->ResetUndo() ;
}