#include "../common.h"

void TaskModeParamater::Finit()
{
	static _TCHAR *(aptcItemLabel[]) =
	{
		_T("Room width") ,
		_T("Room height") ,
		_T("Chipset") ,
		_T("BG bank") ,
		_T("BG palette") ,
		_T("BG animation speed") ,
		_T("Sprite bank") ,
		_T("Sprite palette") ,
		_T("BGM") ,
		_T("Spawn point") ,
		_T("     ") ,
		_T("Tower room") ,
		_T("Special scrolling") ,
		_T("Status color") ,
		_T("") ,
		_T("Manual page placement") ,
		NULL ,
	} ;
	static _TCHAR *(aptcItemComment[]) =
	{
		_T("01-0E") ,
		_T("01-0E") ,
		_T("00-30") ,
		_T("Must be set to match the chipset") ,
		_T("") ,
		_T("In number of frames. 00 : No animation") ,
		_T("Must be set to match enemies in the room") ,
		_T("") ,
		_T("Same number as in sound test") ,
		_T("Check to respawn in previous room (usually for mini-boss rooms)") ,
		_T("") ,
		_T("Check for \"around the tower\" rooms (Butter building)") ,
		_T("Usually 01. Can be up to three. Used for nightmare fight.") ,
		_T("Color modification of BG when triumph (02) or automaticlly (01). Up to 9") ,
		_T("") ,
		_T("When the placement of pages is manual, number of pages") ,
	} ;
	static const int aiType[] =
	{
		0 ,
		0 ,
		0 ,
		0 ,
		0 ,
		0 ,
		0 ,
		0 ,
		0 ,
		1 ,
		-1 ,
		1 ,
		0 ,
		0 ,
		-1 ,
		0 ,
	} ;
	unsigned char *(apucData[]) =
	{
		aucValue+cRoomW ,
		aucValue+cRoomH ,
		aucValue+cChipSet ,
		aucValue+cBGBank ,
		aucValue+cBGPal ,
		aucValue+cBGAni ,
		aucValue+cSprBank ,
		aucValue+cSprPal ,
		aucValue+cBGM ,
		aucValue+cRevival ,
		NULL ,
		aucValue+cTower ,
		aucValue+cRaster ,
		aucValue+cStatus ,
		NULL ,
		aucValue+cManualPage ,
	} ;

	int iY = 30 ;
	int iX = 10 ;
	const int iFontSizeH = 20 ;
	for( int i=0 ; ; iY += iFontSizeH+4,i++ )
	{
		if( !aptcItemLabel[i] )
			{ break ; }
		if( !apucData[i] )
			{ continue ; }

		int iFontWidth = (iFontSizeH*7)/_tcslen( aptcItemLabel[i] ) ;
		new TaskObjectBoxText( this , false , 
			iX , iY , iFontSizeH , iFontWidth/2 , RGB(0,0,0) , RGB(255,255,255) ,
			aptcItemLabel[i] , -1 ) ;
		if( !aiType[i] )
		{
			new TaskObjectBinaryEditor( this , false , 
				iX + iFontSizeH*7 , iY , iFontSizeH ,
				apucData[i] , 1 , 1 ) ;
		}
		else
		{
			tstring strTmp(_T("")) ;
			new TaskObjectCheckBox( this , false , 
				iX + iFontSizeH*7 , iY , iFontSizeH , iFontSizeH ,
				strTmp , apucData[i] ) ;
		}
		new TaskObjectBoxText( this , false , 
			iX + iFontSizeH*7 + iFontSizeH*3/2 , iY , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
			aptcItemComment[i] , -1 ) ;
	}

	{
		Task0810 *pTask ;
		pTask = new TaskObjectBinaryEditor( this , true , 
				iX , iY , iFontSizeH ,
				GL::pFODSW->aucPage , 1 , FODS_PAGE_DATA_SIZE , 1 ) ;
		hPageEditor = 0 ;
		if( pTask )
			{hPageEditor = pTask->GetHandle() ;}
	}
	iCurPageEditorWidth = -1 ;

	{//v[{^̔zu
		static const _TCHAR *(aptcButtonLabel[]) =
		{
			_T("Pool terrain") ,
			_T("Pool object") ,
			_T("Pool door") ,
			_T("Pool all") ,
		} ;
		static void (*apFunc[])(void*) =
		{
			ButtonHandler0 ,
			ButtonHandler1 ,
			ButtonHandler2 ,
			ButtonHandler3 ,
		} ;
		tstring strTmp ;
		for( int i=0 ; i<4 ; i++ )
		{
			strTmp = aptcButtonLabel[i] ;
			new TaskObjectButton( this , false , 
				GL::WINWIDTH-200 , i*32 , 200 , 32 , 16 , aptcButtonLabel[i] , apFunc[i] , this ) ;
		}

	}
	iUpdateChrChip = 0 ;

	SetProcessOrderPandC( true , true ) ;
	SetDrawOrderPandC( true , false ) ;

	return ;
}
void TaskModeParamater::Fmain()
{
	if( IsProcessingBeforeChild() )
	{
		GL::pFODSW->GetRoomParameter(
			aucValue+cRoomW ,
			aucValue+cRoomH ,
			aucValue+cBGBank ,
			aucValue+cBGPal ,
			aucValue+cSprBank ,
			aucValue+cSprPal ,
			aucValue+cBGM ,
			aucValue+cBGAni ,
			aucValue+cRevival ,
			aucValue+cChipSet ,
			aucValue+cTower ,
			aucValue+cRaster ,
			aucValue+cStatus ,
			aucValue+cManualPage 
		) ;
		memcpy_s( aucValuePre , sizeof(aucValuePre) , aucValue , sizeof(aucValue) ) ;

		{
			int iTmpRoomW = aucValue[cRoomW];
			if( !iTmpRoomW ){ iTmpRoomW ++ ; }
			if( iTmpRoomW != iCurPageEditorWidth )
			{
				iCurPageEditorWidth = iTmpRoomW ;
				TaskObjectBinaryEditor *pTask ;
				pTask = (TaskObjectBinaryEditor*)Task0810::SolveHandle( hPageEditor ) ;
				if( pTask )
				{
					pTask->SetDataPerLine( iCurPageEditorWidth ) ;
					GL::RequestRedraw() ;
				}
			}
		}
	}
	else
	{
		if( memcmp( aucValuePre , aucValue , sizeof(aucValuePre) ) )
		{
			GL::pFODSW->SetRoomParameter(
				aucValue[cRoomW] ,
				aucValue[cRoomH] ,
				aucValue[cBGBank] ,
				aucValue[cBGPal] ,
				aucValue[cSprBank] ,
				aucValue[cSprPal] ,
				aucValue[cBGM] ,
				aucValue[cBGAni] ,
				aucValue[cRevival] ,
				aucValue[cChipSet] ,
				aucValue[cTower] ,
				aucValue[cRaster] ,
				aucValue[cStatus] ,
				aucValue[cManualPage]
			) ;
			GL::RequestRedraw() ;
			if( aucValuePre[cChipSet] != aucValue[cChipSet] ||
				aucValuePre[cBGBank] != aucValue[cBGBank] ||
				aucValuePre[cBGPal] != aucValue[cBGPal] ||
				aucValuePre[cStatus] != aucValue[cStatus] ||
				0 )
			{
				UpdateChrChip() ;
			}
		}
	}

	if( iUpdateChrChip )
	{
		TASKHANDLE hTask ;
		TaskModeManager *pTask ;
		if( ( hTask = GetParentHandle() ) &&
			( pTask = (TaskModeManager*)Task0810::SolveHandle( hTask )) )
		{
			pTask->RequestRedrawChip() ;
			pTask->RequestRedrawChr() ;
		}
		iUpdateChrChip = 0 ;
	}
	return ;
}
void TaskModeParamater::Fdest()
{
	return ;
}
void TaskModeParamater::Fdraw()
{
	//`bvpbg\Ă
	GL::mdo.Blt( MDO3WINAPI , GL::SFC_BACK , GL::WINWIDTH-256 , GL::WINHEIGHT-256 , 256 , 256 , GL::SFC_CHIP , 0 , 0 ) ;


	{
		_TCHAR atcTmp[128] ;
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("Room settings mode Room:%03d[%03X]") , GL::iCurRoom , GL::iCurRoom ) ;
		SetWindowText( GL::hWnd , atcTmp ) ;
	}
	return ;
}
void TaskModeParamater::ButtonHandler0( void * pvArg )
{
	GL::pFODSW->DoPoolField() ;
	((TaskModeParamater*)pvArg)->UpdateChrChip() ;
}
void TaskModeParamater::ButtonHandler1( void * pvArg )
{
	GL::pFODSW->DoPoolObj() ;
}
void TaskModeParamater::ButtonHandler2( void * pvArg )
{
	GL::pFODSW->DoPoolDoor() ;
}
void TaskModeParamater::ButtonHandler3( void * pvArg )
{
	GL::pFODSW->DoPoolField() ;
	GL::pFODSW->DoPoolObj() ;
	GL::pFODSW->DoPoolDoor() ;
	((TaskModeParamater*)pvArg)->UpdateChrChip() ;
}
