#include <assert.h>
#include "VersatileTileEditor.h"
#include "mymemorymanage.h"

int VersatileTileEditor::DoEdit()
{
	switch( iDragging )
	{
	case 0:return DoEdit_Sub0() ;
	case 1:return DoEdit_Sub1() ;
	case 2:return DoEdit_Sub2() ;
	}
	assert( 0 ) ;
	return -1 ;
}
void VersatileTileEditor::Draw( MyDIBObj3 *pMDO , int iSFC )
{
	{//I͈͂̕\
		int x0 , x1 , y0 , y1 ;
		x0 = iSelectedX0     * iTileW + iOrgX ;
		x1 = (iSelectedX1+1) * iTileW + iOrgX -1 ;
		y0 = iSelectedY0     * iTileH + iOrgY ;
		y1 = (iSelectedY1+1) * iTileH + iOrgY -1 ;
		pMDO->Box( MDO3WINAPI , iSFC , x0   , y0   , x1   , y1   , myRGB(  0 , 31 ,  0 ) ) ;
		pMDO->Box( MDO3WINAPI , iSFC , x0-1 , y0-1 , x1+1 , y1+1 , myRGB(  0 ,  0 , 31 ) ) ;
		pMDO->Box( MDO3WINAPI , iSFC , x0+1 , y0+1 , x1-1 , y1-1 , myRGB( 31 , 31 ,  0 ) ) ;
	}

	if( iSFCTile>=0 )
	{
		//^Cpbg̕\
		pMDO->Blt( MDO3WINAPI , iSFC , iTilePaletteX , iTilePaletteY ,
					16*iTileW , 16*iTileH , iSFCTile , 0 , 0 ) ;
		{//I^C\
			int iX , iY ;
			iX = iTilePaletteX + iSelectedTile % 16 * iTileW ;
			iY = iTilePaletteY + iSelectedTile / 16 * iTileH ;
			pMDO->Box( MDO3WINAPI , iSFC , iX   , iY   , iX+15   , iY+15   , myRGB(  0 , 31 ,  0 ) ) ;
			pMDO->Box( MDO3WINAPI , iSFC , iX-1 , iY-1 , iX+15+1 , iY+15+1 , myRGB(  0 ,  0 , 31 ) ) ;
			pMDO->Box( MDO3WINAPI , iSFC , iX+1 , iY+1 , iX+15-1 , iY+15-1 , myRGB( 31 , 31 ,  0 ) ) ;
		}
		
		if( pucClip )
		{//Nbv\
			MDO3Opt topt = *MDO3normal ;
			topt.flag |= MDO3F_BLEND ;
			topt.alpha = 0x80 ;
			for( int iY=0 ; iY<iClipH ; iY++ )
			{
			for( int iX=0 ; iX<iClipW ; iX++ )
			{
				int iDX , iDY ;
				int iTile , iTX , iTY ;
				iDX = (iClipX + iX) * iTileW + iOrgX ;
				iDY = (iClipY + iY) * iTileH + iOrgY ;
				iTile = pucClip[ iY*iClipW + iX + 4 ] ;
				iTX = iTile % 16 * iTileW ;
				iTY = iTile / 16 * iTileH ;
				pMDO->Blt( &topt , iSFC , iDX , iDY ,
					iTileW , iTileH , iSFCTile , iTX , iTY ) ;
			} //iX
			} //iY
		}

	}

}
void VersatileTileEditor::LoadClipFile( LPCTSTR filename )
{
	DeletepucClip() ;
	int iFileSize ;
	iFileSize = LoadMemoryFromFile( filename , &pucClip ) ;
	if( iFileSize >= 4 )
	{
		iClipX = iSelectedX0 ;
		iClipY = iSelectedY0 ;
		iClipW = pucClip[1]*256 + pucClip[0] ;
		iClipH = pucClip[3]*256 + pucClip[2] ;
		if( iFileSize != 4 + iClipW*iClipH )
			{DeletepucClip() ;}
	}
	else
	{
		DeletepucClip() ;
	}
}

int VersatileTileEditor::DoEdit_Sub0()
{ //͈͑I𒆈ȊO
	//Undo
	if( KeyPush( KC_PAGEUP ) )
	{
		if( pUndo && pUndo->DoUndo() )
			{return 1 ;}
	}
	if( KeyPush( KC_PAGEDOWN ) )
	{
		if( pUndo && pUndo->DoRedo() )
			{return 1 ;}
	}
	//Rs[
	if( KeyPush( KC_C ) || KeyPush( KC_INS ) )
	{
		DeletepucClip() ;
		iClipW = iSelectedX1-iSelectedX0+1 ;
		iClipH = iSelectedY1-iSelectedY0+1 ;
		pucClip = new unsigned char [ iClipW * iClipH + 4 ] ;
		if( iClipW>0 && iClipH>0 && pucClip )
		{
			iClipX = iSelectedX0 ;
			iClipY = iSelectedY0 ;
			pucClip[0] = iClipW & 0xFF ;
			pucClip[1] = iClipW >> 8 ;
			pucClip[2] = iClipH & 0xFF ;
			pucClip[3] = iClipH >> 8 ;
			for( int iY=0 ; iY<iClipH ; iY++ )
			{
			for( int iX=0 ; iX<iClipW ; iX++ )
			{
				pucClip[ iY*iClipW + iX + 4 ] = GetData( iX+iSelectedX0 , iY+iSelectedY0 ) ;
			} //iX
			} //iY
			if( KeyOn( KC_CTRL ) && _T("") != strClipFileName )
			{
				WriteFileFromMemory( strClipFileName.c_str() , pucClip , iClipW * iClipH + 4 ) ;
			}
		}
		InvalidateKey() ;
		return 1 ;
	}
	//폜
	if( KeyPush( KC_DEL ) )
	{
		InvalidateKey() ;
		for( int iY=iSelectedY0 ; iY<=iSelectedY1 ; iY++ )
		{
		for( int iX=iSelectedX0 ; iX<=iSelectedX1 ; iX++ )
		{
			SetData( iX , iY , iSelectedTile , 0 ) ;
		} //iX
		} //iY
		if( pUndo ){ pUndo->Preserve() ; }
		return 1 ;
	}

	//^Cpbg̏
	if( iSFCTile>=0 )
	{
		int iX , iY , iTX , iTY ;
		iX = GetMousePosX() - iTilePaletteX ;
		iY = GetMousePosY() - iTilePaletteY ;
		iTX = iX / iTileW ;
		iTY = iY / iTileH ;
		if( iX>=0 && iY>=0 && iTX<16 && iTY<16 && MouseOn( MB_L ) )
		{
			InvalidateMouse() ;
			int iTile ;
			iTile = iTX + iTY*16 ;
			if( VAR_LET( iSelectedTile , iTile ) ) { return 1 ; }
			return 0 ;
		}
	}
	{
		int iTmp = 0 ;
		KeyScroll( &iTmp , KC_AR , KC_AL , 1  , 1 , 0 ) ;
		KeyScroll( &iTmp , KC_AD , KC_AU , 16 , 1 , 0 ) ;
		if( iTmp )
		{
			iSelectedTile += iTmp ;
			RotateCorrect( &iSelectedTile , 256 ) ;
			return 1;
		}
	}

	int mx , my ;
	if( !SetMousePosition( &mx , &my ) )
	{
		return 0 ;
	}

	//Nbv̏
	if( pucClip )
	{
		if( MouseOn( MB_R ) || MouseOn( MB_C ) )
		{ //}EXƃNbvI
			DeletepucClip() ;
			InvalidateMouse() ;
			return 1 ;
		}

		int iRV = 0 ;
		if( VAR_LET( iClipX , mx ) ) { iRV = 1 ; }
		if( VAR_LET( iClipY , my ) ) { iRV = 1 ; }
		if( MouseOn( MB_L ) )
		{
			for( int iY=0 ; iY<iClipH ; iY++ )
			{
			for( int iX=0 ; iX<iClipW ; iX++ )
			{
				int iDX , iDY ;
				int iDT , iTile ;
				iDX = (iClipX + iX) ;
				iDY = (iClipY + iY) ;
				if( !IsPositionInData( iDX , iDY ) )
					{ continue ;}
				iDT = GetData( iDX , iDY ) ;
				iTile = pucClip[ iY*iClipW + iX + 4 ] ;
				int iDoProc = 1 ;
				if( KeyOn( KC_SHIFT ) )
				{
					if( iDT!=iSelectedTile ){ iDoProc = 0 ; }
				}
				else if( KeyOn( KC_CTRL ) )
				{
					if( iTile==0 ){ iDoProc = 0 ; }
				}
				if( iDT != iTile && iDoProc )
				{
					iRV = 1 ;
					SetData( iDX , iDY , iTile , 0 ) ;
				}
			} //iX
			} //iY

			InvalidateMouse() ;
		}
		if( MouseRelease( MB_L ) )
		{
			if( pUndo ){ pUndo->Preserve() ; }
		}
		return iRV ;
	}

	if( MousePush( MB_C ) )
	{ //͈͑IJn
		InvalidateMouse() ;
		iSelectedX0 = iSelectedX1 = iDragOrgX = mx ;
		iSelectedY0 = iSelectedY1 = iDragOrgY = my ;
		iDragging = 1 ;
		return 1 ;
	}
	if( MousePush( MB_L ) )
	{ //zu
		InvalidateMouse() ;
		iDragging = 2 ;
		return 1 ;
	}
	if( MouseOn( MB_R ) )
	{ //X|Cg
		InvalidateMouse() ;
		int iTmp = GetData( mx , my ) ;
		assert( iTmp >= 0 ) ;
		if( VAR_LET( iSelectedTile , iTmp ) ) { return 1 ; }
		return 0 ;
	}
	return 0 ;
}
int VersatileTileEditor::DoEdit_Sub1()
{ //{^hbO
	if( !MouseOn( MB_C ) )
	{
		iDragging = 0 ;
		return 0 ;
	}
	InvalidateMouse() ;
	int mx , my ;
	int iX0 , iX1 , iY0 , iY1 ;
	SetMousePositionN( &mx , &my ) ;
	iX0 = iDragOrgX ;
	iX1 = mx ;
	iY0 = iDragOrgY ;
	iY1 = my ;

	if( iX0 > iX1 )
		{ MYSWAP( &iX0 , &iX1 ) ; }
	if( iY0 > iY1 )
		{ MYSWAP( &iY0 , &iY1 ) ; }

	int iRV = 0 ;
	if( VAR_LET( iSelectedX0 , iX0 ) ) { iRV = 1 ; }
	if( VAR_LET( iSelectedX1 , iX1 ) ) { iRV = 1 ; }
	if( VAR_LET( iSelectedY0 , iY0 ) ) { iRV = 1 ; }
	if( VAR_LET( iSelectedY1 , iY1 ) ) { iRV = 1 ; }
	return iRV ;
}
int VersatileTileEditor::DoEdit_Sub2()
{ //{^hbO
	if( !MouseOn( MB_L ) )
	{
		iDragging = 0 ;
		if( pUndo ){ pUndo->Preserve() ; }
		return 0 ;
	}
	InvalidateMouse() ;
	int mx , my ;

	if( !SetMousePosition( &mx , &my ) )
	{ //̊Oɋ珈Ȃ
		return 0 ;
	}
	int iBaseTile = GetData( mx , my ) ;
	if( iBaseTile == iSelectedTile )
	{ //̏ꏊɊɓ^CuĂ珈Ȃ
		return 0 ;
	}

	int iMode = 0 ;
	if( KeyOn( KC_CTRL  ) ){iMode += 2 ;}
	if( KeyOn( KC_SHIFT ) ){iMode += 1 ;}
	
	switch( iMode )
	{
	case 0 : //hԂ
		SetData( mx , my , iSelectedTile , 0 ) ;
	break ;
	case 1 : //hԂ
	case 2 : //chԂ
		{
			SetData( mx , my , iSelectedTile , 0 ) ;
			int iSubMode = iMode - 1 ;
			for( ; iSubMode<4 ; iSubMode+=2 )
			{
				static const int ciTableDx[4] = { -1 ,  0 , 1 , 0 } ;
				static const int ciTableDy[4] = {  0 , -1 , 0 , 1 } ;
				int iX , iY ;
				iX = mx ;
				iY = my ;
				for( int iTimesOut=0 ; iTimesOut<1000000 ; iTimesOut++ )
				{
					iX += ciTableDx[ iSubMode ] ;
					iY += ciTableDy[ iSubMode ] ;
					if( !IsPositionInWindow( iX , iY ) ){ break ; }
					if( GetData( iX , iY ) != iBaseTile ){ break ; }
					SetData( iX , iY , iSelectedTile , 0 ) ;
				}

			}
		}
	break ;
	case 3 : //hԂ
		{
			unsigned char *pucFlag = new unsigned char [ iDataWidth * iDataHeight ] ;
			if( !pucFlag ){ break ; }
			memset( pucFlag , 0 , iDataWidth * iDataHeight ) ;
			SetData( mx , my , iSelectedTile , 0 ) ;
			pucFlag[ GetOffset( mx , my ) ] = 1 ;
			for( int iTimesOut=0 ; iTimesOut<1000000 ; iTimesOut++ )
			{
				int iUpdated = 0 ;
				for( int iY=iWindowY ; iY<iWindowY+iWindowH ; iY++ )
				{
				for( int iX=iWindowX ; iX<iWindowX+iWindowW ; iX++ )
				{
					if( pucFlag[ GetOffset( iX , iY ) ] )
					{
#define FILL_PROC(x,y)														\
						if( IsPositionInWindow( (x) , (y) ) &&				\
							GetData( (x) , (y) ) == iBaseTile )				\
						{													\
							pucFlag[ GetOffset( (x) , (y) ) ] = 1 ;			\
							SetData( (x) , (y) , iSelectedTile , 0 ) ;		\
							iUpdated = 1 ;									\
						}

						pucFlag[ GetOffset( iX , iY ) ] = 0 ;
						FILL_PROC( iX+1 , iY   ) ;
						FILL_PROC( iX-1 , iY   ) ;
						FILL_PROC( iX   , iY+1 ) ;
						FILL_PROC( iX   , iY-1 ) ;
#undef FILL_PROC
					}
				} //iX
				} //iY
				if( !iUpdated ){ break ; }
			}

			delete pucFlag ;
		}
	break ;
	default:
		assert( 0 ) ;
	}

	return 1 ;
}
int VersatileTileEditor::SetMousePosition( int *piX , int *piY )
{ //}EẌʒũ^CPʂ̍W擾
	int iX , iY ;
	iX = GetMousePosX() - iOrgX ;
	iY = GetMousePosY() - iOrgY ;
	iX = GaussDivision( iX , iTileW ) ;
	iY = GaussDivision( iY , iTileH ) ;
	if( !IsPositionInWindow( iX , iY ) )
	{
		*piX = -1 ;
		*piY = -1 ;
		return 0 ;
	}
	*piX = iX ;
	*piY = iY ;
	return 1 ;
}
void VersatileTileEditor::SetMousePositionN( int *piX , int *piY )
{ //}EẌʒũ^CPʂ̍W擾/͂ݏoƂ͋ߖT
	int iX , iY ;
	iX = GetMousePosX() - iOrgX ;
	iY = GetMousePosY() - iOrgY ;
	iX = GaussDivision( iX , iTileW ) ;
	iY = GaussDivision( iY , iTileH ) ;
	if( iX < iWindowX ) iX = iWindowX ;
	if( iY < iWindowY ) iY = iWindowY ;
	if( iX >= iWindowX+iWindowW ) iX = iWindowX+iWindowW-1 ;
	if( iY >= iWindowY+iWindowH ) iY = iWindowY+iWindowH-1 ;
	*piX = iX ;
	*piY = iY ;
	return ;
}

