#define TASK_GUI_CPP
#include "taskGUI.h"
#include "myeinput.h"
#include "keycode.h"
#include "nnsys.h"

MyDIBObj3 *TaskObjectManager::Pmdo = NULL ;
void (*TaskObjectManager::Prr)(void) = NULL ;


void TaskObjectBoxText::Fmain()
{
	if( iTimer<0 ){return;}
	iTimer-- ;
	if( iTimer<0 )
	{
		TaskObjectManager::RequestRedraw() ;
		Suicide() ;
		return ;
	}
	return ;
}
void TaskObjectBoxText::Fdraw()
{
	if(!TaskObjectManager::Pmdo)
	{
		assert(0);
		return ;
	}
	int iPrev = 0 ;
	int iCury = y ;
	
	for( int i=0 ; i>=0 ; )
	{
		tstring strTmp ;
		int iPos ;
		strTmp = strText.c_str()+i ;
		iPos = strTmp.find( _T('\n') ) ;
		if( iPos == string::npos ) {
			i = -1 ;
		} else {
			i += iPos+1 ;
			strTmp.at(iPos) = _T('\0') ;
		}

		TaskObjectManager::Pmdo->Text( 0 , strTmp.c_str() , x-1 , iCury   , iH , iW , uiCol2 ) ;
		TaskObjectManager::Pmdo->Text( 0 , strTmp.c_str() , x+1 , iCury   , iH , iW , uiCol2 ) ;
		TaskObjectManager::Pmdo->Text( 0 , strTmp.c_str() , x   , iCury-1 , iH , iW , uiCol2 ) ;
		TaskObjectManager::Pmdo->Text( 0 , strTmp.c_str() , x   , iCury+1 , iH , iW , uiCol2 ) ;
		TaskObjectManager::Pmdo->Text( 0 , strTmp.c_str() , x   , iCury   , iH , iW , uiCol1 ) ;
		iCury += iH ;

	}
	return ;
}

void TaskObjectSubWindow::Finit()
{
	SetProcessOrderPandC( false , true ) ;
	SetDrawOrderPandC( true , true ) ;
}
void TaskObjectSubWindow::Fmain()
{
	if( (MouseOn( MB_L ) || MouseOn( MB_R ) || MouseOn( MB_C ) ) &&
		RectIn( GetMousePosX() , GetMousePosY() , x , y , iW , iH ) )
	{
		InvalidateMouse() ;
	}
}
void TaskObjectSubWindow::Fdraw()
{
	if(!TaskObjectManager::Pmdo)
	{
		assert(0);
		return ;
	}
	if( IsDrawingBeforeChild() )
	{
		TaskObjectManager::Pmdo->GetClipper( 0 , &iClipX , &iClipY , &iClipW , &iClipH ) ;
		TaskObjectManager::Pmdo->SetClipper( 0 , x , y , iW , iH ) ;
		if( Col < 0x8000 )
		{
			TaskObjectManager::Pmdo->Cls( MDO3WINAPI , 0 , x , y , iW , iH , Col ) ;
		}
	}
	else
	{
		TaskObjectManager::Pmdo->SetClipper( 0 , iClipX , iClipY , iClipW , iClipH ) ;
	}
}
void TaskObjectBinaryEditor::Finit()
{
	iIsChanged = 0 ;
}
void TaskObjectBinaryEditor::Fmain()
{
	if( iSelectedPosition >= 0 )
	{
int iTmp ;
		iTmp = GetNumberKey(true) ;
		if( iTmp != -1 )
		{
			pfuncModifyDataColumn( this , iTmp ) ;
			iSelectedPosition++ ;
			if( iSelectedPosition/iWorkBytesPerNumber>=iDataSize )iSelectedPosition = -1 ;
			TaskObjectManager::RequestRedraw() ;
			InvalidateKeyCode( KC_0 ) ;
			InvalidateKeyCode( KC_1 ) ;
			InvalidateKeyCode( KC_2 ) ;
			InvalidateKeyCode( KC_3 ) ;
			InvalidateKeyCode( KC_4 ) ;
			InvalidateKeyCode( KC_5 ) ;
			InvalidateKeyCode( KC_6 ) ;
			InvalidateKeyCode( KC_7 ) ;
			InvalidateKeyCode( KC_8 ) ;
			InvalidateKeyCode( KC_9 ) ;
			InvalidateKeyCode( KC_A ) ;
			InvalidateKeyCode( KC_B ) ;
			InvalidateKeyCode( KC_C ) ;
			InvalidateKeyCode( KC_D ) ;
			InvalidateKeyCode( KC_E ) ;
			InvalidateKeyCode( KC_F ) ;
			iIsChanged = 1 ;
		}
		int iShift = 0 ;
		KeyScroll( &iShift , KC_J , KC_M , 1  , 1 , 0 ) ;
		KeyScroll( &iShift , KC_H , KC_N , 16 , 1 , 0 ) ;
		if( iShift )
		{
			int iVal = pData[iSelectedPosition/iWorkBytesPerNumber] ;
			iVal += iShift ;
			RotateCorrect( &iVal , 256 ) ;
			pData[iSelectedPosition/iWorkBytesPerNumber] = iVal ;
			InvalidateKey() ;
			TaskObjectManager::RequestRedraw() ;
			iIsChanged = 1 ;
		}
	}
	int iInField = 1 ;
	int iPointed ;
	int iRX ;
	{
		int tx , ty , cx , cy ;
		tx = GetMousePosX() - x ;
		ty = GetMousePosY() - y ;
		cx = tx / iWorkNumberSpan ;
		cy = ty / iFontSize ;
		iRX = tx % iWorkNumberSpan / iWorkColumnWidth ;
		iPointed = cx + cy * iDataPerLine ;
		if( tx<0 || ty<0 ){ iInField = 0 ; }
		if( cx>=iDataPerLine ){ iInField = 0 ; }
		if( iRX>=iWorkBytesPerNumber ){ iInField = 0 ; }
		if( iPointed>=iDataSize ){ iInField = 0 ; }
	}
	if( iInField )
	{
		if( MousePush( MB_L ) )
		{
			InvalidateMouse() ;
			iSelectedPosition = iPointed*iWorkBytesPerNumber+iRX ;
			TaskObjectManager::RequestRedraw() ;
		}
	}
	else
	{
		if( MouseOn( MB_L ) && iSelectedPosition >= 0 )
		{
			iSelectedPosition = -1 ;
			TaskObjectManager::RequestRedraw() ;
		}
	}
}
void TaskObjectBinaryEditor::Fdest()
{
}
void TaskObjectBinaryEditor::Fdraw()
{
	for( int i=0 ; i<iDataSize ; i++ )
	{
		int tx, ty ;
		tx = x + i % iDataPerLine * iWorkNumberSpan ;
		ty = y + i / iDataPerLine * iFontSize ;
		TaskObjectManager::Pmdo->Cls( MDO3WINAPI , 0 , tx , ty , iWorkBytesPerNumber*iWorkColumnWidth , iFontSize , myRGB(31,31,31) ) ;
		if( iSelectedPosition>=0 && iSelectedPosition/iWorkBytesPerNumber == i )
		{
			TaskObjectManager::Pmdo->Cls( MDO3WINAPI , 0 , tx+iSelectedPosition%iWorkBytesPerNumber*iWorkColumnWidth , ty , iWorkColumnWidth , iFontSize , myRGB(0,31,0) ) ;
		}
		_TCHAR atcTmp[16] ;
		_stprintf_s( atcTmp , _countof(atcTmp) , ptcDrawFormat , pfuncGetValue(this,i) ) ;
		TaskObjectManager::Pmdo->Text( 0 , atcTmp , tx , ty , iFontSize , iFontSize/2 , RGB(0,0,0) ) ;
	}
}

void TaskObjectCheckBox::Fmain()
{
	int tx , ty ;
	tx = GetMousePosX() - x ;
	ty = GetMousePosY() - y ;
	if( tx>=0 && ty>=0 && tx<iW && ty<iH )
	{
		if( MousePush( MB_L ) )
		{
			InvalidateMouse() ;
			if( *pucData ){ *pucData = 0 ; }
			else { *pucData = 1 ; }
			TaskObjectManager::RequestRedraw() ;
		}
	}

}
void TaskObjectCheckBox::Fdraw()
{
	TaskObjectManager::Pmdo->Cls( MDO3WINAPI , 0 , x , y , iW , iH , myRGB(31,31,31) ) ;
	if( *pucData )
	{
		int x0,x1,x2,y0,y1,y2 ;
		x0 = x + iW*1/8 ;
		x1 = x + iW*3/8 ;
		x2 = x + iW*7/8 ;
		y0 = y + iH*4/8 ;
		y1 = y + iH*7/8 ;
		y2 = y + iH*1/8 ;

		TaskObjectManager::Pmdo->Line( MDO3normal , 0 , x0 , y0 , x1 , y1 , myRGB(0,0,0) ) ;
		TaskObjectManager::Pmdo->Line( MDO3normal , 0 , x1 , y1 , x2 , y2 , myRGB(0,0,0) ) ;
	}
	TaskObjectManager::Pmdo->Text( 0 , strText.c_str() , x+iW , y , iH , iH/2 , RGB(0,0,0) ) ;
}
void TaskObjectRotateList::Fmain()
{
	int tx , ty ;
	tx = GetMousePosX() - x ;
	ty = GetMousePosY() - y ;


	if( !iDragging )
	{
		if( tx>=0 && ty>=0 && tx<iW && ty<iFontSize*iRows )
		{
			if( MousePush( MB_L ) )
			{
				InvalidateMouse() ;
				int iTmp ;
				iTmp = *piData - iRows/2 + ty/iFontSize ;
				RotateCorrect( &iTmp , iMaxItem ) ;
				*piData = iTmp ;
				TaskObjectManager::RequestRedraw() ;
				iIsChanged = 1 ;
			}
			if( MousePush( MB_C ) )
			{
				InvalidateMouse() ;
				iDragging = 1 ;
				iDragPreX = GetMousePosX() ;
				iDragPreY = GetMousePosY() ;
			}
		}
	}
	else
	{
		if( !MouseOn( MB_C ) )
		{
			iDragging = 0 ;
			TaskObjectManager::RequestRedraw() ;
		}
		else
		{
			InvalidateMouse() ;
			int dx , dy ;
			dx = GetMousePosX() - iDragPreX ;
			dy = GetMousePosY() - iDragPreY ;
			x += dx ;
			y += dy ;
			if( dx && dy )
			{
				TaskObjectManager::RequestRedraw() ;
			}
			iDragPreX = GetMousePosX() ;
			iDragPreY = GetMousePosY() ;
		}
	}
}
void TaskObjectRotateList::Fdraw()
{
	int iTopItem ;
	iTopItem = *piData - iRows/2 ;

	for( int i=0 ; i<iRows ; i++ )
	{
		int iItemNum ;
		int iY ;
		BMPD color ;
		iItemNum = iTopItem+i ;
		RotateCorrect( &iItemNum , iMaxItem ) ;
		iY = y + i*iFontSize ;
		color = myRGB(31,31,31) ;
		if( i==iRows/2 )
			{color = myRGB(0,31,0) ; }
		_TCHAR atcTmp[16] ;
		_stprintf_s( atcTmp , _countof(atcTmp) , _T("%02X") , iItemNum ) ;
		TaskObjectManager::Pmdo->Cls ( MDO3WINAPI , 0 , x , iY , iW , iFontSize , color ) ;
		TaskObjectManager::Pmdo->Text( 0 , atcTmp                     , x           , iY , iFontSize , iFontSize/2 , RGB(0,0,0) ) ;
		if( pstrItem )
		{
		TaskObjectManager::Pmdo->Text( 0 , pstrItem[iItemNum].c_str() , x+iFontSize , iY , iFontSize , iFontSize/2 , RGB(0,0,0) ) ;
		}
	}
}

void TaskObjectButton::Finit()
{

}
void TaskObjectButton::Fmain()
{
	int iPreDragging = iDragging ;
	if( RectIn( GetMousePosX() , GetMousePosY() , x , y , iW , iH ) )
	{
		if( MousePush( MB_L ) || iDragging )
		{
			iDragging = 1 ;
			if( MouseRelease( MB_L ) )
			{
				if( pFunc )
				{
					pFunc( pvArgument ) ;
				}
				iDragging = 0 ;
			}
		}
		if( MouseOn( MB_L ) )
		{
			InvalidateMouse() ;
		}
	}
	else
	{
		if( iDragging )
		{
			iDragging = 2 ;
			if( !MouseOn( MB_L ) )
			{
				iDragging = 0 ;
			}
		}
	}
	if( iPreDragging != iDragging )
	{
		TaskObjectManager::RequestRedraw() ;
	}
}
void TaskObjectButton::Fdest()
{

}
void TaskObjectButton::Fdraw()
{
	int iSW  ;
	int iDY ;
	BMPD Color1 , Color2 ;

	iSW = min(iW,iH)/32+1 ;
	Color1 = myRGB(31,31,31) ;
	Color2 = myRGB( 0, 0, 0) ;
	iDY = 0 ;
	if( iDragging&1 )
	{
		MYSWAP( &Color1 , &Color2 ) ;
		iDY = iSW ;
	}

	TaskObjectManager::Pmdo->Cls ( MDO3WINAPI , 0 , x     , y     , iW       , iH       , Color1 ) ;
	TaskObjectManager::Pmdo->Cls ( MDO3WINAPI , 0 , x+iSW , y+iSW , iW-iSW*1 , iH-iSW*1 , Color2 ) ;
	TaskObjectManager::Pmdo->Cls ( MDO3WINAPI , 0 , x+iSW , y+iSW , iW-iSW*2 , iH-iSW*2 , myRGB(25,25,25) ) ;

	int iX ;
	SIZE tFontRect ;
	tFontRect = TaskObjectManager::Pmdo->TestText( 0 , strCaption.c_str() , iFontSize , iFontSize/2 ) ;
	iX = x + ( iW - tFontRect.cx ) / 2 ;
	TaskObjectManager::Pmdo->Text( 0 , strCaption.c_str() , iX+iDY  , y+(iH-iFontSize)/2+iDY , iFontSize , iFontSize/2 , RGB(0,0,0) ) ;


}
