#include "fods.h"

#ifdef _ORE_SENYOU
#include "KirbyCode/twinkle.h"
#else
#include "twinkle.h"
#endif


#define ADDR_BGBankSet			0x059418
#define ADDR_BankRoom			0x1284D1 //
#define ADDR_RevivalPosition	0x1284D1 //̂Q͓ꏊɂ
#define ADDR_ChipSet			0x128618



#define ADDR_SPROOM_RASTER_ROOM_LO	0x13A37A
#define ADDR_SPROOM_RASTER_ROOM_HI	0x13A37D
#define ADDR_SPROOM_RASTER_VAL		(0x13A380+1)
#define ADDR_SPROOM_TOWER_ROOM_LO	0x13A384
#define ADDR_SPROOM_TOWER_ROOM_HI	0x13A388

#define ADDR_SPROOM_STATUS1_ROOM_LO	0x13A766
#define ADDR_SPROOM_STATUS1_ROOM_HI	0x13A76F
#define ADDR_SPROOM_STATUS2_ROOM_LO	0x13A717
#define ADDR_SPROOM_STATUS2_ROOM_HI	0x13A71E

#define ADDR_STATUS0_COLOR1			0x13A737
#define ADDR_STATUS0_COLOR2			0x13A73C
#define ADDR_STATUS0_COLOR3			0x13A741
#define ADDR_STATUS1_COLOR1			0x13A747
#define ADDR_STATUS1_COLOR2			0x13A74C
#define ADDR_STATUS1_COLOR3			0x13A751
#define ADDR_STATUS2_COLOR1			0x13A757
#define ADDR_STATUS2_COLOR2			0x13A75C
#define ADDR_STATUS2_COLOR3			0x13A761

void FODS_OBJ::Draw( MyDIBObj3 *pMDO , int iSFC , int iBaseX , int iBaseY )
{
	int tx,ty ;
	tx = iX*FODS_TILE_SIZE+iBaseX ;
	ty = iY*FODS_TILE_SIZE+iBaseY ;
	BMPD color ;
	color = myRGB(31,31,0) ;
	if( IsSelected() ){ color = myRGB(31,0,0); }
	pMDO->Cls( MDO3WINAPI , iSFC , tx , ty , FODS_TILE_SIZE , FODS_TILE_SIZE , color ) ;
	_TCHAR atcTmp[16] ;
	_stprintf_s( atcTmp , _countof( atcTmp ) , _T("%02X") , iT ) ;
	pMDO->Text( iSFC , atcTmp , tx , ty , FODS_TILE_SIZE , FODS_TILE_SIZE/2 , RGB(0,0,0) ) ;
}
void FODS_DOOR::Draw( MyDIBObj3 *pMDO , int iSFC , int iBaseX , int iBaseY )
{
	int tx,ty ;
	tx = iX*FODS_TILE_SIZE+iBaseX ;
	ty = iY*FODS_TILE_SIZE+iBaseY ;
	BMPD color ;
	color = myRGB(31,31,0) ;
	if( IsSelected() ){ color = myRGB(31,0,0); }
	pMDO->Cls( MDO3WINAPI , iSFC , tx , ty , 16 , 16 , color ) ;
	_TCHAR atcTmp[16] ;
	_stprintf_s( atcTmp , _countof( atcTmp ) , _T("%02X") , iT ) ;
	pMDO->Text( iSFC , atcTmp , tx , ty , FODS_TILE_SIZE , FODS_TILE_SIZE/2 , RGB(0,0,0) ) ;
}



int FODS_OBJ_UNIT::Add( int iX , int iY , int iT )
{
	int iSuffix = SeekUnusedToken() ;
	if( iSuffix >= 0 )
	{
		Token[iSuffix].Put( iX , iY , iT ) ;
	}
	return iSuffix ;
}
int FODS_DOOR_UNIT::Add( int iX , int iY , int iT , int iDestR , int iDestP , int iDestX , int iDestY )
{
	int iSuffix = SeekUnusedToken() ;
	if( iSuffix >= 0 )
	{
		Token[iSuffix].Put( iX , iY , iT ) ;
		Token[iSuffix].Modify( iX , iY , iT , iDestR , iDestP , iDestX , iDestY ) ;
	}
	return iSuffix ;
}

void FODS_OBJ_UNIT::SetupImage( unsigned char *pucOut )
{
	memset( pucOut , 0 , FODS_TOTAL_OBJECT_DATA_SIZE ) ;

	for( int i=0 ; i<iMaxToken ; i++ )
	{
		Token[i].SetupImage( pucOut+i*FODS_BYTE_P_OBJECT ) ;
	}
}
void FODS_DOOR_UNIT::SetupImage( unsigned char *pucOut )
{
	memset( pucOut , 0 , FODS_TOTAL_DOOR_DATA_SIZE ) ;

	for( int i=0 ; i<iMaxToken ; i++ )
	{
		Token[i].SetupImage( pucOut+i*FODS_BYTE_P_OBJECT ) ;
	}
}
int FODS_OBJ_UNIT::SetupData( unsigned char **ppucOut , int iRoomW , int iRoomH )
{
	unsigned char aucWorking[ 2 + 0x100 + iMaxToken * 2 ] ;
	int iPageNum[ iMaxToken ] ;
	int iRoomH_ ;
	int iMaxObj ;
	iRoomH_ = ( iRoomH * FODS_CHIP_P_PAGE_H + FODS_CHIP_P_PAGE_H_E - 1 ) / FODS_CHIP_P_PAGE_H_E ;

	iMaxObj = 0 ;
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		iPageNum[i] = -1 ;
		if( Token[i].IsExist() )
		{
			int x , y ;
			x = Token[i].GetX() ;
			y = Token[i].GetY() ;
			if( x>=0 && y>=0 && x<iRoomW*FODS_CHIP_P_PAGE_W && y<iRoomH_*FODS_CHIP_P_PAGE_H_E )
			{
				iPageNum[i] = y/FODS_CHIP_P_PAGE_H_E*iRoomW + x/FODS_CHIP_P_PAGE_W ;
				iMaxObj ++ ;
			}
		}
	}

	aucWorking[0] = iRoomH_*iRoomW ;
	aucWorking[1] = iRoomH ;

	int iWPosType ;
	{//y[W̔zu
		int iMaxPage_ ;
		int iWPosPage ;
		int iWPosPos ;
		int iObjNumber ;
		iMaxPage_ = iRoomH_*iRoomW ;
		iWPosPage = 2 ;
		iWPosPos  = 2 + iMaxPage_ ;
		iWPosType = 2 + iMaxPage_ + iMaxObj ;
		iObjNumber = 0 ;
		for( int ip=0 ; ip<iMaxPage_ ; ip++ )
		{
			for( int i=0 ; i<iMaxToken ; i++ )
			{
				if( iPageNum[i] == ip )
				{
					int t , x , y ;
					t = Token[i].GetT() ;
					x = Token[i].GetX() ;
					y = Token[i].GetY() ;
					aucWorking[ iWPosPos ++ ] = ((x<<4)&0xF0)|(y&0x0F) ;
					aucWorking[ iWPosType++ ] = t ;
					iObjNumber ++ ;
				}
			}
			aucWorking[ iWPosPage++ ] = iObjNumber ;
		}
		assert( iObjNumber == iMaxObj ) ;
	}
	unsigned char *pTmp ;
	pTmp = ( unsigned char * )malloc( iWPosType ) ;
	if( !pTmp ){ return -1 ; }
	memcpy( pTmp , aucWorking , iWPosType ) ;
	(*ppucOut) = pTmp ;
	return iWPosType ;
}
int FODS_DOOR_UNIT::SetupData( unsigned char **ppucOut , int iRoomW )
{
	unsigned char aucWorking[ 5 * iMaxToken ] ;
	int iWPos = 0 ;
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		if( Token[i].IsExist() )
		{
			int t , x , y ,dr , dp , dx , dy ;
			t = Token[i].GetT() ;
			x = Token[i].GetX() ;
			y = Token[i].GetY() ;
			dr = Token[i].GetDestR() ;
			dp = Token[i].GetDestP() ;
			dx = Token[i].GetDestX() ;
			dy = Token[i].GetDestY() ;
			int lx , ly , p ;
			lx = x % FODS_CHIP_P_PAGE_W ;
			ly = y % FODS_CHIP_P_PAGE_H ;
			p  = y / FODS_CHIP_P_PAGE_H * iRoomW + x / FODS_CHIP_P_PAGE_W ;
			aucWorking[ iWPos + 0 ] = (( t<<4)&0xF0) | ( p&0x0F) ;
			aucWorking[ iWPos + 1 ] = ((lx<<4)&0xF0) | (ly&0x0F) ;
			aucWorking[ iWPos + 2 ] = (dr&0xFF) ;
			aucWorking[ iWPos + 3 ] = ((dr>>1)&0x80) | (t&0x70) | (dp&0x0F) ;
			aucWorking[ iWPos + 4 ] = ((dx<<4)&0xF0) | (dy&0x0F) ;
			
			iWPos += 5 ;
		}
	}
	if( !iWPos )return 0 ;
	unsigned char *pTmp ;
	pTmp = ( unsigned char * )malloc( iWPos ) ;
	if( !pTmp ){ return -1 ; }
	memcpy( pTmp , aucWorking , iWPos ) ;
	(*ppucOut) = pTmp ;
	return iWPos ;
}

#define FODS_TOKEN_UNIT FODS_OBJ_UNIT
#include "fods_p_tokenUnit_c.h"
#undef FODS_TOKEN_UNIT
#define FODS_TOKEN_UNIT FODS_DOOR_UNIT
#include "fods_p_tokenUnit_c.h"
#undef FODS_TOKEN_UNIT

//ÓIɊmۂꂽApsetpr̊֐KvƂȂ邽߁A
//sDł邪AŃ|C^mۂĂB
static MyDIBObj3 *psMDO ;

static void CLSFUNC( int sfc , int x , int y , int w , int h , UINT c )
{
	psMDO->Cls( MDO3normal , sfc , x , y , w , h , c ) ;
}


FODS::FODS( MyDIBObj3 *pMDO , BMPD *pBMPD , int iSfcChr , int iSfcChip , int iSfcChifInfo , unsigned char *pucRom , int iRomSize , int iUndoBuffer )
{
	Clear() ;
	//`n
	if( pMDO )
	{
		this->pMDO         = pMDO ;
		this->NESColor     = pBMPD ;
		this->iSfcChr      = iSfcChr ;
		this->iSfcChip     = iSfcChip ;
		this->iSfcChipInfo = iSfcChifInfo ;
		psMDO = pMDO ;
		SetNESDrawRoutine( CLSFUNC , NULL ) ;
		pMDO->CreateSurface( iSfcChr , 128 , 128 ) ;
		pMDO->CreateSurface( iSfcChip , 256 , 256 ) ;
		pMDO->CreateSurface( iSfcChifInfo , 256 , 256 ) ;
		pMDO->LoadBitmapFile( iSfcChifInfo , _T("data\\chipinfo.bmp") ) ;
	}
	//ROMn
	if( pucRom )
	{
		this->pucRom = pucRom ;
		this->iRomSize = iRomSize ;
		iFieldSizeOnROM = -1 ;
		iFieldAddrOnROM = -1 ;
		iObjSizeOnROM = -1 ;
		iObjAddrOnROM = -1 ;
		iDoorSizeOnROM = -1 ;
		iDoorAddrOnROM = -1 ;
		iPrgSize = pucRom[4]*0x4000 ;
		EMU.SetRomData( pucRom ) ;
		if( iRomSize != iPrgSize+pucRom[5]*0x2000+0x10 )
		{
			this->pucRom = NULL ;
		}
	}
	pVTE = new VersatileTileEditor( aucField , FODS_CHIP_P_FIELD_W , FODS_CHIP_P_FIELD_H , FODS_TILE_SIZE , FODS_TILE_SIZE , iUndoBuffer ) ;
}

int FODS::Save( LPCTSTR ptcFilename )
{
	unsigned char aucObjImage[FODS_TOTAL_OBJECT_DATA_SIZE] = {0} ;
	unsigned char aucDoorImage[FODS_TOTAL_DOOR_DATA_SIZE] = {0} ;
	ObjUnit.SetupImage( aucObjImage ) ;
	DoorUnit.SetupImage( aucDoorImage ) ;
 
	TextIOManager *pTIOM = GetTIOM( ptcFilename , aucObjImage , aucDoorImage , 0 ) ;
	int iRV = pTIOM->DoSaving() ;
	delete pTIOM ;
	return iRV ;
}
int FODS::Load( LPCTSTR ptcFilename )
{
	unsigned char aucObjImage[FODS_TOTAL_OBJECT_DATA_SIZE] = {0} ;
	unsigned char aucDoorImage[FODS_TOTAL_DOOR_DATA_SIZE] = {0} ;

	TextIOManager *pTIOM ;
	int iRV ;
	pTIOM = GetTIOM( ptcFilename , aucObjImage , aucDoorImage , 1 ) ;
	iRV = pTIOM->DoLoading() ;
	delete pTIOM ;
	if( !iRV )
	{
		if( iPoolField )
			{ ClearField(); }
		if( iPoolObj )
			{ ClearObj(); }
		if( iPoolDoor)
			{ ClearDoor(); }
		pTIOM = GetTIOM( ptcFilename , aucObjImage , aucDoorImage , 0 ) ;
		iRV = pTIOM->DoLoading() ;
		delete pTIOM ;
		if( iPoolObj )
			{ObjUnit.ApplyImage( aucObjImage ) ;}
		if( iPoolDoor)
			{DoorUnit.ApplyImage( aucDoorImage ) ;}
	}
	return iRV ;
}

TextIOManager *FODS::GetTIOM( LPCTSTR ptcFilename , unsigned char *pucObjImage , unsigned char *pucDoorImage , int iPoolFlag ) 
{
	TextIOManager *pTIOM = new TextIOManager( ptcFilename , 100 , _T('#') , _T(';') ) ;

	if( !iPoolFlag )
	{
		pTIOM->AddIOItem_Comment( _T("DreamTool Room data file") ) ;
		pTIOM->AddIOItem_Comment( _T("") ) ;
		pTIOM->AddIOItem_Comment( _T("Neo website") ) ;
		pTIOM->AddIOItem_Comment( _T("http://borokobo.web.fc2.com/neo/index.html") ) ;
		pTIOM->AddIOItem_Comment( _T("Annex (Kirby)") ) ;
		pTIOM->AddIOItem_Comment( _T("http://www4.atpages.jp/borokobo/index.html") ) ;
		pTIOM->AddIOItem_Comment( _T("Translated by UraKn0x") ) ;
		pTIOM->AddIOItem_Comment( _T("") ) ;

		pTIOM->AddIOItem_16Value( _T("P_VERSION") , &iVersion ) ;
	}
	pTIOM->AddIOItem_16Value( _T("P_POOL_FIELD") , &iPoolField ) ;
	pTIOM->AddIOItem_16Value( _T("P_POOL_OBJECT") , &iPoolObj) ;
	pTIOM->AddIOItem_16Value( _T("P_POOL_DOOR") , &iPoolDoor ) ;

	if( iPoolFlag )
	{
		return pTIOM ;
	}
	pTIOM->AddIOItem_16Value( _T("P_WIDTH") , &iWidth ) ;
	pTIOM->AddIOItem_16Value( _T("P_HEIGHT") , &iHeight ) ;
	pTIOM->AddIOItem_16Value( _T("P_BG_BANK") , &iBGbank ) ;
	pTIOM->AddIOItem_16Value( _T("P_BG_PAL") , &iBGpal ) ;
	pTIOM->AddIOItem_16Value( _T("P_SPR_BANK") , &iSPRbank ) ;
	pTIOM->AddIOItem_16Value( _T("P_SPR_PAL") , &iSPRpal ) ;
	pTIOM->AddIOItem_16Value( _T("P_BGM") , &iBGM ) ;
	pTIOM->AddIOItem_16Value( _T("P_BG_BANK_SP") , &iBGbank_sp ) ;
	pTIOM->AddIOItem_16Value( _T("P_REVIVE_POS") , &iRevivePos ) ;
	pTIOM->AddIOItem_16Value( _T("P_CHIP_SET") , &iChipSet ) ;
	pTIOM->AddIOItem_16Value( _T("P_SP_ROOM_TOWER") , &iSpRoom_Tower ) ;
	pTIOM->AddIOItem_16Value( _T("P_SP_ROOM_RASTER") , &iSpRoom_Raster ) ;
	pTIOM->AddIOItem_16Value( _T("P_SP_ROOM_STATUS") , &iSpRoom_Status ) ;
	pTIOM->AddIOItem_16Value( _T("P_MANUAL_PAGE_MAPPING") , &iManualPageMapping ) ;

	pTIOM->AddIOItem_Block( _T("PAGE") , aucPage , FODS_PAGE_DATA_SIZE ) ;
	if( iPoolField )
		{pTIOM->AddIOItem_Block( _T("FIELD") , aucField , FODS_FIELD_SIZE ) ; }
	else
		{pTIOM->AddIOItem_Comment( _T("Maps are not pool objects") ) ;}
	if( iPoolObj )
		{pTIOM->AddIOItem_Block( _T("OBJECT") , pucObjImage , FODS_TOTAL_OBJECT_DATA_SIZE ) ;}
	else
		{pTIOM->AddIOItem_Comment( _T("Object is not pool object") ) ;}
	if( iPoolDoor )
		{pTIOM->AddIOItem_Block( _T("DOOR") , pucDoorImage , FODS_TOTAL_DOOR_DATA_SIZE ) ;}
	else
		{pTIOM->AddIOItem_Comment( _T("Door is not pool object") ) ;}

	pTIOM->AddIOItem_Comment( _T("") ) ;
	pTIOM->AddIOItem_Comment( _T("*** Setting the editor below ***") ) ;
	pTIOM->AddIOItem_Comment( _T("") ) ;
	pTIOM->AddIOItem_16Value( _T("ViewX") , &iViewX ) ;
	pTIOM->AddIOItem_16Value( _T("ViewY") , &iViewY ) ;
	return pTIOM ;
}


void FODS::DrawChr()
{
	if( !pMDO || !pucRom )return ;

	int chrbank[4] ;
	chrbank[0] = 0x00 ;
	for( int i=1 ; i<4 ; i++ )
	{
		chrbank[i] = GetROM8( ADDR_BGBankSet+iBGbank+0x100*(i-1)) ;
	}
	for( int i=0 ; i<256 ; i++ )
	{
		int tx,ty ;
		tx = i%16*8 ;
		ty = i/16*8 ;
		DrawNESCharacter( pucRom+(0x10+iPrgSize+i%0x40*0x10+0x400*chrbank[i/0x40]) , iSfcChr , tx , ty , false , 1 ) ;
	}
}


void FODS::DrawChip( int mode )
{
	if( !pMDO || !pucRom )return ;
	pMDO->Cls( MDO3WINAPI , iSfcChip , 0 , 0 , 256 , 256 , myRGB(0,0,0) );
//J[pbg
	BMPD CT[16] ;
	if( mode==1 )
	{
		for( int i=0 ; i<4 ; i++)
		{
			CT[i*4  ] = myRGB(0,0,0) ;
			CT[i*4+1] = myRGB(10,10,10) ;
			CT[i*4+2] = myRGB(20,20,20) ;
			CT[i*4+3] = myRGB(31,31,31) ;
		}
	}
	else if ( mode==2 )
	{
		for( int i=0 ; i<4 ; i++)
		{
			CT[i*4  ] = myRGB(10,10,10) ;
			CT[i*4+1] = myRGB(14,14,14) ;
			CT[i*4+2] = myRGB(18,18,18) ;
			CT[i*4+3] = myRGB(22,22,22) ;
		}
	}
	else
	{
		CT[12] = NESColor[GetROM8(iBGpal)];
		switch( iSpRoom_Status )
		{
		case 1:
			CT[13] = NESColor[GetROM8(ADDR_STATUS1_COLOR1)];
			CT[14] = NESColor[GetROM8(ADDR_STATUS1_COLOR2)];
			CT[15] = NESColor[GetROM8(ADDR_STATUS1_COLOR3)];
		break ;
		case 2:
			CT[13] = NESColor[GetROM8(ADDR_STATUS2_COLOR1)];
			CT[14] = NESColor[GetROM8(ADDR_STATUS2_COLOR2)];
			CT[15] = NESColor[GetROM8(ADDR_STATUS2_COLOR3)];
		break ;
		default:
			CT[13] = NESColor[GetROM8(ADDR_STATUS0_COLOR1)];
			CT[14] = NESColor[GetROM8(ADDR_STATUS0_COLOR2)];
			CT[15] = NESColor[GetROM8(ADDR_STATUS0_COLOR3)];
		}
		for( int i=0 ; i<3 ; i++)
		{
			CT[i*4  ] = CT[12];
			CT[i*4+1] = NESColor[GetROM8(iBGpal+0x0100+0x0300*i)];
			CT[i*4+2] = NESColor[GetROM8(iBGpal+0x0200+0x0300*i)];
			CT[i*4+3] = NESColor[GetROM8(iBGpal+0x0300+0x0300*i)];
		}
	}
//`bvf[^G~WJ

	EMU.Initialize() ;
	EMU.EasyInitialize( 0x38ACDB , 0x00 , 0x12 , 0x38 , 0x3E , 0x3F ) ;
	EMU.WriteY(iChipSet) ;
	char *Prv ;
	Prv = EMU.OprateUntilRTS( 0x10000 ) ;
	if( Prv[0]!=0x20 )
	{ //Ȃ߂l̃xOJĂȂςȎdl
		return ;
	}
//`bv`Jn
	
	MDO3Opt topt = *MDO3normal;
	BYTE *Pram = EMU.GetRAMPointer() ;

	topt.flag |= MDO3F_USE_COLOR_TABLE;
	for( int i=0 ; i<256 ; i++ )
	{
		int drawchip = i ;
		if( mode==3 )
		{
static BYTE BrakableChip[256] =
{
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 1,1,1,0,
	1,1,0,0, 0,1,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,1,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,1,
	1,1,0,1, 1,0,1,1, 1,0,0,0, 0,0,0,0,

	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
	0,0,0,0, 0,0,0,0, 0,0,0,0, 0,0,0,0,
} ;
			if( BrakableChip[Pram[0x7F00+i]] )drawchip -= 8 ;
			if( drawchip < 0 )drawchip+=256 ;
		}

		topt.PBMPD = &CT[(Pram[0x7E00+drawchip]&3)*4];
		for( int q=0 ; q<4 ; q++)
		{
			int bField ;
			bField = Pram[0x7a00+q*0x100+drawchip] ;
			pMDO->Blt( &topt , iSfcChip , i%16*16+q%2*8 , i/16*16+q/2*8 , 8 , 8 , iSfcChr ,
				bField%16*8 , bField/16*8 );
		}
//蔻
		if( mode==2 )
		{
			int bField ;
			bField = Pram[0x7F00+i] ;
			pMDO->Blt( MDO3normal , iSfcChip , i%16*16 , i/16*16 , 16 , 16 , iSfcChipInfo ,
				bField%16*16 , bField/16*16 );
		}
//j\
		if( mode==3 )
		{
			if( drawchip == i )
			{

				MDO3Opt half = *MDO3normal ;
				half.flag |= MDO3F_BLEND ;
				half.alpha = 0xB0 ;
				pMDO->Cls( &half , iSfcChip , i%16*16 , i/16*16 , 16 , 16 , myRGB(16,16,16) );
			}
		}
	}
}
void FODS::DrawRoom( int sfc )
{
	int iDrawWidth = iWidth ;
	int iDrawHeight = iHeight ;
	DurCorrect( &iDrawWidth  , 0 , FODS_PAGE_P_FIELD_W ) ;
	DurCorrect( &iDrawHeight , 0 , FODS_PAGE_P_FIELD_H ) ;
	for( int iy=0 ; iy<iDrawHeight*FODS_CHIP_P_PAGE_H ; iy++ )
	{
		for( int ix=0 ; ix<iDrawWidth*FODS_CHIP_P_PAGE_W ; ix++ )
		{
			int ch ;
			ch = GetFieldData( ix , iy ) ;
			int tx,ty ;
			tx = iViewX + ix*16 ;
			ty = iViewY + iy*16 ;
			pMDO->Blt( MDO3normal , sfc , tx , ty , 16 , 16 , iSfcChip , ch%16*16 , ch/16*16 ) ;
		}
	}
	for( int ix=1 ; ix<iWidth ; ix++ )
	{
		int tx,th ;
		tx = iViewX+ix*16*FODS_CHIP_P_PAGE_W ;
		th = iHeight*16*FODS_CHIP_P_PAGE_H ;
		pMDO->Cls( MDO3normal , sfc , tx , iViewY , 1 , th , myRGB(0,31,0) ) ;
	}
	for( int iy=1 ; iy<iHeight ; iy++ )
	{
		int ty,tw ;
		ty = iViewY+iy*16*FODS_CHIP_P_PAGE_H ;
		tw = iWidth*16*FODS_CHIP_P_PAGE_W ;
		pMDO->Cls( MDO3normal , sfc , iViewX , ty , tw , 1 , myRGB(0,31,0) ) ;
	}
}
int FODS::LoadRoomFromROM( int iRoom )
{
	Clear() ;
	if( !pucRom )return 0 ;

	EMU.EasyInitialize( 0x3FE662 , 0x00 , 0x12 , 0x38 , 0x3E , 0x3F ) ;
	EMU.WriteY(iChipSet) ;
	EMU.WriteAdrW(0x055e,iRoom) ;

	{//G~ǂ𓮂}bvWJ
		char *Prv ;
		Prv = EMU.OprateUntilRTSwithBreak( 0x100 , 0x3F , 0xE683 ) ;
		if( Prv[0] != _6502m_BREAK )
			{ return 0 ; }
		iFieldAddrOnROM = EMU.GetA()<<16 ;
		iFieldSizeOnROM = iFieldAddrOnROM ;
		EMU.OprateUntilRTSwithBreak( 0x100 , 0x3F , 0xE693 ) ;
		if( Prv[0] != _6502m_BREAK )
			{ return 0 ; }
		iFieldAddrOnROM |= ( EMU.GetAdr(0x16) | ( EMU.GetAdr(0x17)<<8 ) ) ;
		EMU.OprateUntilRTSwithBreak( 0x10000 , 0x3F , 0xE696 ) ;
		if( Prv[0] != _6502m_BREAK )
			{ return 0 ; }
		iFieldSizeOnROM += ( EMU.GetAdr(0x16) | ( EMU.GetAdr(0x17)<<8 ) ) ;
		iFieldSizeOnROM += EMU.GetY()+1 ;
		iFieldSizeOnROM -= iFieldAddrOnROM ;
	}

	BYTE *Pram = EMU.GetRAMPointer() ;

	{//[̑擾
		iWidth     = Pram[0x67EE] ;
		iHeight    = Pram[0x67EF] ;
		iBGbank    = Pram[0x67F0] ;
		iBGpal     = Pram[0x67F1] ;
		iSPRbank   = Pram[0x67F2] ;
		iSPRpal    = Pram[0x67F3] ;
		iBGM       = Pram[0x67F4] ;
		iBGbank_sp = Pram[0x67F5] ;

		iRevivePos = GetROM8( ADDR_RevivalPosition+iRoom ) & 0x80 ;
		iChipSet   = GetROM8( ADDR_ChipSet        +iRoom ) ;

		//Xoʓ|Ȑݒ(e[uɊ܂܂Ă邩ǂ̔f)
		iSpRoom_Tower = 0 ;
		for( int i=0 ; i<SIZE_SPROOM_TOWER ; i++ )
		{
			if( GetROM8(ADDR_SPROOM_TOWER_ROOM_LO+i)+
				GetROM8(ADDR_SPROOM_TOWER_ROOM_HI+i)*256 == iRoom )
			{
				iSpRoom_Tower = 1 ;
			}
		}
		iSpRoom_Raster = 1 ;
		for( int i=0 ; i<SIZE_SPROOM_RASTER ; i++ )
		{
			if( GetROM8(ADDR_SPROOM_RASTER_ROOM_LO+i)+
				GetROM8(ADDR_SPROOM_RASTER_ROOM_HI+i)*256 == iRoom )
			{
				iSpRoom_Raster = GetROM8(ADDR_SPROOM_RASTER_VAL+i) ;
			}
		}
		iSpRoom_Status = 0 ;
		for( int i=0 ; i<SIZE_SPROOM_STATUS1 ; i++ )
		{
			if( GetROM8(ADDR_SPROOM_STATUS1_ROOM_LO+i)+
				GetROM8(ADDR_SPROOM_STATUS1_ROOM_HI+i)*256 == iRoom )
			{
				iSpRoom_Status = 1 ;
			}
		}
		for( int i=0 ; i<SIZE_SPROOM_STATUS2 ; i++ )
		{
			if( GetROM8(ADDR_SPROOM_STATUS2_ROOM_LO+i)+
				GetROM8(ADDR_SPROOM_STATUS2_ROOM_HI+i)*256 == iRoom )
			{
				iSpRoom_Status = 2 ;
			}
		}
	}

	{//y[W̔zu擾
		memcpy( aucPage  , &Pram[0x67F6] , FODS_PAGE_DATA_SIZE ) ;
	}

	{//`bvzu擾@qnlł̍\ƈႢAcɍLȃ`bvzu쐬
		int iMaxPage = 0  ;
		for( int i=0 ; i<iWidth*iHeight ; i++ )
		{
			if( i>=FODS_PAGE_DATA_SIZE )break ;
			int rp ;
			int tx,ty ;
			rp = aucPage[i] ;
			if( iMaxPage< rp )
				{ iMaxPage = rp ;}

			tx = i%iWidth ;
			ty = i/iWidth ;

			tx *= FODS_CHIP_P_PAGE_W ;
			ty *= FODS_CHIP_P_PAGE_H ;

			//y[WɉPCAmemcpy
			for( int q=0 ; q<FODS_CHIP_P_PAGE_H ; q++ )
			{
				int iDestOffset , iSrcOffset ;
				iDestOffset = tx + (ty+q)*FODS_CHIP_P_FIELD_W ;
				iSrcOffset  = (rp*FODS_CHIP_P_PAGE_S+q*FODS_CHIP_P_PAGE_W) ;
				if( iDestOffset>=FODS_FIELD_SIZE )break ;
				if( iSrcOffset>=FODS_PAGE_LIMIT*FODS_CHIP_P_PAGE_S )break ;
				memcpy( aucField+iDestOffset , 
						Pram+0x68C8+iSrcOffset ,
						FODS_CHIP_P_PAGE_W ) ;
			}
		}
		iManualPageMapping = iMaxPage + 1 ;
	}


//G̓ǂݏo
	for(;;)
	{
/*
	Ey[Wf@iy[Wfccʂ̃y[WƈčQTUsNZj
	EsAy[W̍ɂȂĂ
	Ey[Wf̐@ǂǂ܂ł̃y[Wf̓GiŌ̃y[Wf́AsAG̐ɂȂj
	EG̐Ay[W[Jʒuixxxx yyyyj
	EG̐A̎
*/
		int NOenemy = 0 ;

		int adr ;
		adr  = GetROM8(0x128D0E+iRoom) ;
		adr |= GetROM8(0x128BC7+iRoom)<<8 ;
		adr |= GetROM8(0x128A80+iRoom)<<16 ;
		iObjAddrOnROM = adr ;

		int sc[FODS_MAX_OBJECT] ;
		int nosc ;
		int no_enemy ;
		int rwidth = iWidth ;
		if( !rwidth )
			{break ;}

		nosc = GetROM8( adr ) ;
		adr ++ ;
		//ɓ̂PoCgȉcƈvj
		adr ++ ;
		for( int i=0 ; i<nosc ; i++ )
		{
			sc[i] = GetROM8( adr ) ;
			adr ++ ;
		}
		no_enemy = GetROM8( adr-1 ) ;

		if( no_enemy >= FODS_MAX_OBJECT )
			{break ;}

		NOenemy = no_enemy ;
		iObjSizeOnROM = 2 + nosc + NOenemy * 2 ;

		int csc =0 ;
		for( int i=0 ; i<NOenemy ; i++ )
		{//ƂăAȋC邪AGP̂Ƃ肾
			for( int q=0 ; q<nosc ; q++ )
			{
				if( sc[q] > i )
				{
					csc = q ;
					break ;
				}
			}
			int tx , ty , tt ;
			tx = csc%rwidth * 16 ;
			tx += (GetROM8( adr+i )>>  4) ;
			ty = csc/rwidth * 16 ;
			ty += (GetROM8( adr+i ) &0xF) ;
			tt = GetROM8( adr+i+NOenemy ) ;
			ObjUnit.Add( tx , ty , tt ) ;
		}
		break ;
	}
//hA̓ǂݏo
	for(;;)
	{
/*
ToCg
ttttpppp xxxxyyyy rrrrrrrr RTTTPPPP XXXXYYYY

TTTtttt...hÃ^CviȂƂȂԂɂj

pppp...hA̒uĂy[W
xxxx...hA̒uĂy[W[J
yyyy...hA̒uĂy[W[J

Rrrrrrrrr...o惋[
PPPP...oy[W
XXXX...oy[W[J
YYYY...oy[W[J
*/
		int rwidth = iWidth ;
		if( !rwidth ) break ;

		int adro , adre ;
		adro  = GetROM8(0x128F82+iRoom) ;
		adro |= GetROM8(0x1290CB+iRoom)<<8 ;
		adro |= 0x12<<16 ;
		adre  = GetROM8(0x128F82+iRoom+1) ;
		adre |= GetROM8(0x1290CB+iRoom+1)<<8 ;
		adre |= 0x12<<16 ;
		iDoorAddrOnROM = adro ;
		iDoorSizeOnROM = adre-adro ;

		for( int to=0 ; to<FODS_MAX_DOOR ; to++ )
		{
			if( adro >= adre )break ;
			int tx,ty,tt ;
			tx  = (GetROM8( adro+0 )&0xF)%rwidth*16 ;
			ty  = (GetROM8( adro+0 )&0xF)/rwidth*12 ;
			tx += (GetROM8( adro+1 ) >>4) ;
			ty += (GetROM8( adro+1 )&0xF) ;
			tt =  ((GetROM8( adro+3 )&0x70) ) ;
			tt += ((GetROM8( adro+0 )&0xF0)>>4) ;

			int ttr,ttp,ttx,tty ;
			ttr = ((GetROM8( adro+3 )&0x80)<<1)|(GetROM8( adro+2 )) ;
			ttp = (GetROM8( adro+3 )&0xF) ;
			ttx = (GetROM8( adro+4 )>>4) ;
			tty = (GetROM8( adro+4 )&0xF) ;

			DoorUnit.Add( tx , ty , tt , ttr , ttp , ttx , tty ) ;

			adro += 5 ;
		}
		break ;
	}
	return 1 ;
}

unsigned char FODS::GetFieldData( int offset )
{
	if( offset<0 || offset >=FODS_FIELD_SIZE ){assert(0);return 0 ;}
	return aucField[ offset ] ;
}
unsigned char FODS::GetFieldData( int gx , int gy )
{
	if( gx<0 || gx>=iWidth*FODS_CHIP_P_PAGE_W  || gx>=FODS_CHIP_P_FIELD_W ){assert(0);return 0 ;}
	if( gy<0 || gy>=iHeight*FODS_CHIP_P_PAGE_H || gy>=FODS_CHIP_P_FIELD_H ){assert(0);return 0 ;}
	return GetFieldData( gx + gy*FODS_CHIP_P_FIELD_W ) ;
}
/*
unsigned char FODS::GetFieldData( int page , int lx , int ly )
{
	if( page<0 || page>=FODS_PAGE_LIMIT ){assert(0);return 0 ;}
	if( lx<0 || lx>=FODS_CHIP_P_PAGE_W ){assert(0);return 0 ;}
	if( ly<0 || ly>=FODS_CHIP_P_PAGE_H ){assert(0);return 0 ;}
	return GetFieldData( (page%iWidth*FODS_CHIP_P_PAGE_W+lx) + 
		(page/iWidth*FODS_CHIP_P_PAGE_H+ly)*FODS_CHIP_P_FIELD_W ) ;
}
*/

int FODS::SetupRoomData( unsigned char **ppucOut )
{
	int iMaxPage ;
	unsigned char aucWorking[ FODS_ROOM_OFFSET_DATA + FODS_PAGE_LIMIT * FODS_CHIP_P_PAGE_S ] ;
	int iDataSize ; 

	//Kvȃy[WvZ
	iMaxPage = iManualPageMapping ;
	if( !iMaxPage )
	{ iMaxPage = iWidth*iHeight ; }
	DurCorrect( &iMaxPage , 1 , FODS_PAGE_LIMIT ) ;
	//TCYvZ
	iDataSize = FODS_ROOM_OFFSET_DATA + iMaxPage * FODS_CHIP_P_PAGE_S ;
	//m
	memset( aucWorking , 0 , iDataSize ) ;

	//p[^zu
	aucWorking[0] = iWidth ;
	aucWorking[1] = iHeight ;
	aucWorking[2] = iBGbank ;
	aucWorking[3] = iBGpal ;
	aucWorking[4] = iSPRbank ;
	aucWorking[5] = iSPRpal ;
	aucWorking[6] = iBGM ;
	aucWorking[7] = iBGbank_sp ;
	//y[Wzu
	{
		if( iManualPageMapping )
		{//}jAzûƂ̓Rs[
			memcpy( aucWorking+FODS_ROOM_OFFSET_PAGE , aucPage , FODS_PAGE_DATA_SIZE ) ;
		}
		else
		{//zûƂ́Aʐς̕lm
			for( int i=0 ; i<aucWorking[0]*aucWorking[1] ; i++ )
			{ aucWorking[FODS_ROOM_OFFSET_PAGE+i] = i%FODS_PAGE_LIMIT ; }
		}
	}
	//}bv
	{
		for( int py=0 ; py<aucWorking[1] ; py++ )
		{for( int px=0 ; px<aucWorking[0] ; px++ )
		{
			int iPageNum ;
			unsigned char *pDest ;
			if( iManualPageMapping )
			{ //}jAzu
				iPageNum = aucPage[ py * aucWorking[0] + px ] % iMaxPage ;
			}
			else
			{ //zu
				iPageNum = ( py * aucWorking[0] + px ) % iMaxPage ;
			}
			pDest = aucWorking + FODS_ROOM_OFFSET_DATA + iPageNum * FODS_CHIP_P_PAGE_S ;
			for( int i=0 ; i<FODS_CHIP_P_PAGE_H ; i++ )
			{ 
				memcpy( pDest + i * FODS_CHIP_P_PAGE_W , 
						aucField + ( py * FODS_CHIP_P_PAGE_H + i ) * FODS_CHIP_P_FIELD_W + 
						px * FODS_CHIP_P_PAGE_W , FODS_CHIP_P_PAGE_W ) ; 
			}
		}}//px,py
	}

	int iRV ;
	iRV = TwinkleEncode( ppucOut , aucWorking , iDataSize , 0 ) ;
	return iRV ;
}
int FODS::SetupObjData( unsigned char **ppucOut )
{
	return ObjUnit.SetupData( ppucOut , iWidth , iHeight ) ;
}
int FODS::SetupDoorData( unsigned char **ppucOut )
{
	return DoorUnit.SetupData( ppucOut , iWidth ) ;
}
void FODS::UpdateROM( int iRoom , int *piTower , int *piRaster , int *piStatus1 , int *piStatus2 )
{
	{
		int iTmp ;
		iTmp = GetROM8( ADDR_RevivalPosition+iRoom ) & ~0x80 ;
		if( iRevivePos ){ iTmp |= 0x80 ; }
		SetROM8( ADDR_RevivalPosition+iRoom , iTmp ) ;
	}
	SetROM8( ADDR_ChipSet + iRoom , iChipSet ) ;

	if( iSpRoom_Tower && piTower )
	{
		if( *piTower < SIZE_SPROOM_TOWER )
		{
			SetROM8( ADDR_SPROOM_TOWER_ROOM_LO + *piTower , iRoom&0xFF ) ;
			SetROM8( ADDR_SPROOM_TOWER_ROOM_HI + *piTower , iRoom>>8 ) ;
		}
		piTower[0]++ ;
	}
	if( iSpRoom_Raster!=1 && piRaster )
	{
		if( *piRaster < SIZE_SPROOM_RASTER )
		{
			static int Table[SIZE_SPROOM_RASTER] = { 0 , 2 , 1 } ;
			int iOff = Table[*piRaster] ;
			SetROM8( ADDR_SPROOM_RASTER_ROOM_LO + iOff , iRoom&0xFF ) ;
			SetROM8( ADDR_SPROOM_RASTER_ROOM_HI + iOff , iRoom>>8 ) ;
			SetROM8( ADDR_SPROOM_RASTER_VAL     + iOff , iSpRoom_Raster ) ;
		}
		piRaster[0]++ ;
	}
	if( iSpRoom_Status==1 && piStatus1 )
	{
		if( *piStatus1 < SIZE_SPROOM_STATUS1 )
		{
			SetROM8( ADDR_SPROOM_STATUS1_ROOM_LO + *piStatus1 , iRoom&0xFF ) ;
			SetROM8( ADDR_SPROOM_STATUS1_ROOM_HI + *piStatus1 , iRoom>>8 ) ;
		}
		piStatus1[0]++ ;
	}
	if( iSpRoom_Status==2 && piStatus2 )
	{
		if( *piStatus2 < SIZE_SPROOM_STATUS2 )
		{
			SetROM8( ADDR_SPROOM_STATUS2_ROOM_LO + *piStatus2 , iRoom&0xFF ) ;
			SetROM8( ADDR_SPROOM_STATUS2_ROOM_HI + *piStatus2 , iRoom>>8 ) ;
		}
		piStatus2[0]++ ;
	}
}

