#include <windows.h>
#include <assert.h>
#include "TextIO.h"
#include "mydibobj3.h"
#include "VersatileTileEditor.h"

#ifdef _ORE_SENYOU

#include "HT/NESsys.h"
#include "FCEMU/_6502m.h"

#else

#include "NESsys.h"
#include "_6502m.h"

#endif

#ifndef FODS_HEADER_INCLUDED
#define FODS_HEADER_INCLUDED


//GfB^̐
//GfB^Ŏ苎邩ȂB܂ǂ͂Ȃcc
#define FODS_PAGE_P_FIELD_W	0x0F  //ő剡y[W
#define FODS_PAGE_P_FIELD_H	0x0F  //őcy[W
#define FODS_PAGE_P_FIELD_S	(FODS_PAGE_P_FIELD_W*FODS_PAGE_P_FIELD_H) //Q̐

#define FODS_PAGE_DATA_SIZE 0xD2  //y[WzũTCY

#define FODS_CHIP_P_PAGE_W	0x10  //y[W̉`bv
#define FODS_CHIP_P_PAGE_H	0x0C  //y[W̏c`bv
#define FODS_CHIP_P_PAGE_H_E	0x10  //G̔zuɊւ鎞̃y[W̏c`bv
#define FODS_CHIP_P_PAGE_S	(FODS_CHIP_P_PAGE_W*FODS_CHIP_P_PAGE_H)  //Q̐
#define FODS_PAGE_LIMIT		0xE   //j[Nȃy[W

#define FODS_CHIP_P_FIELD_W	(FODS_CHIP_P_PAGE_W*FODS_PAGE_P_FIELD_W)  //}bv̉ő`bv
#define FODS_CHIP_P_FIELD_H	(FODS_CHIP_P_PAGE_H*FODS_PAGE_P_FIELD_H)  //}bv̏cő`bv
#define FODS_CHIP_P_FIELD_S	(FODS_CHIP_P_PAGE_S*FODS_PAGE_P_FIELD_S)  //Q̐


#define FODS_BYTE_P_OBJECT	0x10   //PIuWFNg̃GfB^ł̗e
#define FODS_MAX_OBJECT		0x100  //IuWFNgő吔(ȂȂ)
#define FODS_TOTAL_OBJECT_DATA_SIZE	(FODS_BYTE_P_OBJECT*FODS_MAX_OBJECT)  //Q̐

#define FODS_BYTE_P_DOOR	0x20  //PhÃGfB^ł̗e
#define FODS_MAX_DOOR		0x100 //hA̍ő吔(ȂȂ)
#define FODS_TOTAL_DOOR_DATA_SIZE	(FODS_BYTE_P_DOOR*FODS_MAX_DOOR)  //Q̐


#define FODS_FIELD_SIZE		(FODS_CHIP_P_FIELD_S)  //tB[h̃GfB^ł̗e
#define FODS_TILE_SIZE		16

#define FODS_MAX_ROOM       0x147
#define FODS_ROOM_PARAM_SIZE	8
#define FODS_ROOM_OFFSET_PAGE	(FODS_ROOM_PARAM_SIZE)
#define FODS_ROOM_OFFSET_DATA	(FODS_ROOM_PARAM_SIZE+FODS_PAGE_DATA_SIZE)

#define SIZE_SPROOM_RASTER			3
#define SIZE_SPROOM_TOWER			4
#define SIZE_SPROOM_STATUS1			9
#define SIZE_SPROOM_STATUS2			1


#include "fods_p_token.h"
#include "fods_p_tokenUnit.h"


class FODS
{
public:
	static const int cLatestVersion = 0x0100 ;
	FODS_OBJ_UNIT ObjUnit ;
	FODS_DOOR_UNIT DoorUnit ;
	VersatileTileEditor *pVTE ;
	unsigned char aucPage[FODS_PAGE_DATA_SIZE] ;


	//RXgN^MDO3ւ̃|C^ƁAROMւ̃|C^nƂoB
	//ȒlnꂽƂ́A`惋[`ƁAROM̃f[^̓ǂݏo𗘗p邱ƂoB
	FODS()
	{Clear() ;}
	FODS( MyDIBObj3 *pMDO , BMPD *pBMPD , int iSfcChr , int iSfcChip , int iSfcChifInfo , unsigned char *pucRom , int iRomSize , int iUndoBuffer ) ;
	~FODS()
	{
		delete pVTE ;
	}
	int Save( LPCTSTR ptcFilename ) ;
	int Load( LPCTSTR ptcFilename ) ;
	void Clear()
	{
		ClearField() ;
		ClearObj() ;
		ClearDoor() ;
		
		iVersion = cLatestVersion ;
		iPoolField = 0 ;
		iPoolObj = 0 ;
		iPoolDoor = 0 ;

		iViewX = 0 ;
		iViewY = 0 ;
	}

	
	void DrawChr() ;
	void DrawChip( int mode ) ;
	void DrawRoom( int sfc ) ;
	int LoadRoomFromROM( int room ) ;

	unsigned char GetFieldData( int offset ) ;
	unsigned char GetFieldData( int gx , int gy ) ;
//	unsigned char GetFieldData( int page , int lx , int ly ) ;
//	void SetData( int offset , BYTE val ) ;
//	void SetData( int gx , int gy , BYTE val ) ;
//	void SetData( int page , int lx , int ly , BYTE val ) ;

	void SetViewPosition( int iViewX , int iViewY )
	{
		this->iViewX = iViewX ;
		this->iViewY = iViewY ;
	}
	void GetViewPosition( int *piViewX , int *piViewY )
	{
		if( piViewX ){ *piViewX = iViewX ; }
		if( piViewY ){ *piViewY = iViewY ; }
	}
	void SetVTEWindow()
	{
		pVTE->SetWindow( 0 , 0 , iWidth*FODS_CHIP_P_PAGE_W , iHeight*FODS_CHIP_P_PAGE_H ) ;
	}
	void GetRoomParameter( unsigned char *pucWidth , unsigned char *pucHeight , 
		unsigned char *pucBGbank , unsigned char *pucBGpal , 
		unsigned char *pucSPRbank , unsigned char *pucSPRpal , 
		unsigned char *pucBGM , unsigned char *pucBGbank_sp , 
		unsigned char *pucRevivePos , unsigned char *pucChipSet , 
		unsigned char *pucSpRoom_Tower , unsigned char *pucSpRoom_Raster , 
		unsigned char *pucSpRoom_Status , unsigned char *pucManualPageMapping)
	{
		if( pucWidth ){ *pucWidth = iWidth ; } 
		if( pucHeight ){ *pucHeight = iHeight ; } 
		if( pucBGbank ){ *pucBGbank = iBGbank ; } 
		if( pucBGpal ){ *pucBGpal = iBGpal ; } 
		if( pucSPRbank ){ *pucSPRbank = iSPRbank ; } 
		if( pucSPRpal ){ *pucSPRpal = iSPRpal ; } 
		if( pucBGM ){ *pucBGM = iBGM ; } 
		if( pucBGbank_sp ){ *pucBGbank_sp = iBGbank_sp ; } 
		if( pucRevivePos ){ *pucRevivePos = iRevivePos ; } 
		if( pucChipSet ){ *pucChipSet = iChipSet ; } 
		if( pucSpRoom_Tower ){ *pucSpRoom_Tower = iSpRoom_Tower ; } 
		if( pucSpRoom_Raster ){ *pucSpRoom_Raster = iSpRoom_Raster ; } 
		if( pucSpRoom_Status ){ *pucSpRoom_Status = iSpRoom_Status ; } 
		if( pucManualPageMapping ){ *pucManualPageMapping = iManualPageMapping ; } 
	}
	void SetRoomParameter( int iWidth , int iHeight , 
		int iBGbank , int iBGpal , 
		int iSPRbank , int iSPRpal , 
		int iBGM , int iBGbank_sp , 
		int iRevivePos , int iChipSet , 
		int iSpRoom_Tower , int iSpRoom_Raster , 
		int iSpRoom_Status , int iManualPageMapping)
	{
		this->iWidth = iWidth ;
		this->iHeight = iHeight ;
		this->iBGbank = iBGbank ;
		this->iBGpal = iBGpal ;
		this->iSPRbank = iSPRbank ;
		this->iSPRpal = iSPRpal ;
		this->iBGM = iBGM ;
		this->iBGbank_sp = iBGbank_sp ;
		this->iRevivePos = iRevivePos ;
		this->iChipSet = iChipSet ;
		this->iSpRoom_Tower = iSpRoom_Tower ;
		this->iSpRoom_Raster = iSpRoom_Raster ;
		this->iSpRoom_Status = iSpRoom_Status ;
		this->iManualPageMapping = iManualPageMapping ;
	}
	int IsFieldPooled(){ return iPoolField ; }
	int IsObjPooled(){ return iPoolObj ; }
	int IsDoorPooled(){ return iPoolDoor ; }
	void DoPoolField(){ iPoolField=1 ; ClearField() ; }
	void DoPoolObj()  { iPoolObj  =1 ; ClearObj  () ; }
	void DoPoolDoor() { iPoolDoor =1 ; ClearDoor () ; }

	int SetupRoomData( unsigned char **ppucOut ) ;
	int SetupObjData ( unsigned char **ppucOut ) ;
	int SetupDoorData( unsigned char **ppucOut ) ;
	void UpdateROM( int iRoom , int *piTower , int *piRaster , int *piStatus1 , int *piStatus2 ) ;

	void GetDefaultFieldSpace( int *piAddr , int *piSize )
	{
		if( piAddr ){ *piAddr = iFieldAddrOnROM ; }
		if( piSize ){ *piSize = iFieldSizeOnROM ; }
	}
	void GetDefaultObjSpace( int *piAddr , int *piSize )
	{
		if( piAddr ){ *piAddr = iObjAddrOnROM ; }
		if( piSize ){ *piSize = iObjSizeOnROM ; }
	}
	void GetDefaultDoorSpace( int *piAddr , int *piSize )
	{
		if( piAddr ){ *piAddr = iDoorAddrOnROM ; }
		if( piSize ){ *piSize = iDoorSizeOnROM ; }
	}

//	int BuildRawRoomData( BYTE **PPout ) ;
//	int BuildObjectData( BYTE **PPout ) ;
//	int BuildDoorData( BYTE **PPout ) ;
//	void OverWriteEtcSettingToROM( BYTE *Prom , int romsize , int room ) ;
private:
	unsigned char aucField[FODS_FIELD_SIZE] ;



	int iVersion ;
	//v[
	int iPoolField ;
	int iPoolObj ;
	int iPoolDoor ;
	//[̐ݒ
	int iWidth ;
	int iHeight ;
	int iBGbank ;
	int iBGpal ;
	int iSPRbank ;
	int iSPRpal ;
	int iBGM ;
	int iBGbank_sp ;
	//kf[^Ɋ܂܂Ȃݒ
	int iRevivePos ; //0ŋ
	int iChipSet ;
	int iSpRoom_Tower ; //0ŋ
	int iSpRoom_Raster ; //ʏ01
	int iSpRoom_Status ; //ʏ00 ݒ01or02
	int iManualPageMapping ; //ʏ00ŃI[g

	//ȉ̒l𗘗p邩ǂ͔C
	//`n
	MyDIBObj3 *pMDO ;
	int iSfcChr ;
	int iSfcChip ;
	int iSfcChipInfo ;
	int iViewX ;
	int iViewY ;
	BMPD *NESColor ;
	//ROMn
	unsigned char *pucRom ;
	int iRomSize ;
	int iPrgSize ;
	int iFieldSizeOnROM ;
	int iFieldAddrOnROM ;
	int iObjSizeOnROM ;
	int iObjAddrOnROM ;
	int iDoorSizeOnROM ;
	int iDoorAddrOnROM ;
	unsigned char *ROM( int iAddr ){ return pucRom+ ( ( ( (((unsigned int)(iAddr)>>16)&0xFF)*0x2000 | ((unsigned int)(iAddr)&0x1FFF)  )%(iPrgSize) ) + 0x10) ; }
	void SetROM8 ( int iAddr , int iVal ){ if(!pucRom)return;ROM(iAddr)[0]=iVal; }
	void SetROM16( int iAddr , int iVal ){ SetROM8(iAddr+0,iVal);SetROM8(iAddr+1,iVal>>8); }
	void SetROM24( int iAddr , int iVal ){ SetROM16(iAddr+0,iVal);SetROM8(iAddr+2,iVal>>16); }
	void SetROM32( int iAddr , unsigned int iVal ){ SetROM16(iAddr+0,iVal);SetROM16(iAddr+2,iVal>>16); }
	int GetROM8 ( int iAddr ){ if(!pucRom)return 0;return ROM(iAddr)[0]; }
	int GetROM16( int iAddr ){ if(!pucRom)return 0;return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8); }
	int GetROM24( int iAddr ){ if(!pucRom)return 0;return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8)|(ROM(iAddr+2)[0]<<16); }
	unsigned int GetROM32( int iAddr ){ if(!pucRom)return 0;return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8)|(ROM(iAddr+2)[0]<<16)|((unsigned int)(ROM(iAddr+3)[0])<<24); }
	FCEmuMinus EMU ;

	
	TextIOManager *GetTIOM( LPCTSTR ptcFilename , unsigned char *pucObjImage , unsigned char *pucDoorImage , int iPoolFlag=0 ) ;
	void ClearField()
	{
		memset( aucField  , 0 , FODS_FIELD_SIZE ) ;
		memset( aucPage   , 0 , FODS_PAGE_DATA_SIZE ) ;
		iWidth = 1 ;
		iHeight = 1 ;
		iBGbank = 0 ;
		iBGpal = 0 ;
		iSPRbank = 0 ;
		iSPRpal = 0 ;
		iBGM = 0 ;
		iBGbank_sp = 0 ;
		iRevivePos = 0 ;
		iChipSet = 0 ;
		iSpRoom_Tower = 0 ;
		iSpRoom_Raster = 1 ;
		iSpRoom_Status = 0 ;
		iManualPageMapping = 0 ;
	}
	void ClearObj() { ObjUnit.Clear() ; }
	void ClearDoor() { DoorUnit.Clear() ; }
} ;



#endif /*FODS_HEADER_INCLUDED*/

