
#ifndef FODS_P_TOKEN_UNIT_HEADER_INCLUDED
#define FODS_P_TOKEN_UNIT_HEADER_INCLUDED

#if 1
class FODS_OBJ_UNIT
{
public:
	static const int iMaxToken = FODS_MAX_OBJECT ;
	FODS_OBJ_UNIT()
		{ Clear() ; }
	~FODS_OBJ_UNIT(){;}

	void Clear()
		{ for(int i=0;i<iMaxToken;i++)Token[i].Clear(); CorrectSelectValue(); }
	int  Add( int iX , int iY , int iT ) ;

	void Select( int iSuffix , int iSingle ) ;
	void Deselect( int iSuffix ) ;

	void SelectAll()
		{for( int i=0 ; i<iMaxToken ; i++ ){Token[i].Select();  } CorrectSelectValue(); }
	void DeselectAll()
		{for( int i=0 ; i<iMaxToken ; i++ ){Token[i].Deselect();} CorrectSelectValue(); }

	void Delete( int iSuffix )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].Delete();CloseToken();}
	void Modify( int iSuffix , int iX , int iY , int iT )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].Modify(iX,iY,iT);}
	void ModifyDelta( int iSuffix , int iX , int iY , int iT )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].ModifyDelta(iX,iY,iT);}
	int GetType()
	{
		if( iSelected < 0 ){ return -1 ; }
		return Token[iSelected].GetT() ;
	}
	//ȉ̃I[o[[hꂽ֐͑Iꂽ̂ɍp
	void Delete()
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected()){Delete(i);i--;}}
	void Modify( int iX , int iY , int iT )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected())Modify(i,iX,iY,iT);}
	void ModifyDelta( int iX , int iY , int iT )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected())ModifyDelta(i,iX,iY,iT);}

	void SetupImage( unsigned char *pucOut ) ;
	void ApplyImage( unsigned char *pucIn ) ;
	int SetupData( unsigned char **ppucOut , int iRoomW , int iRoomH ) ;

	void InitEditing() ;
	int DoEdit( int iBaseX , int iBaseY ) ;
	void Draw( MyDIBObj3 *pMDO , int iSFC , int iBaseX , int iBaseY )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsExist()){ Token[i].Draw( pMDO , iSFC , iBaseX , iBaseY ) ; }}

private:
	FODS_OBJ Token[iMaxToken] ;
	int iSelected ;
	int iDragging ;
	int iDragPreX , iDragPreY ;
	void CloseToken() ;
	void CorrectSelectValue() ;
	int  SeekUnusedToken() ;
	int  SeekByPosition( int iX , int iY ) ;
	int DoEdit_Sub0( int iBaseX , int iBaseY ) ;
	int DoEdit_Sub1( int iBaseX , int iBaseY ) ;
	void InitDrag( int iX , int iY )
	{
		iDragging = 1 ;
		iDragPreX = iX ;
		iDragPreY = iY ;
	}
};

/*
@قƂǂ܂NXQ`Ƃ
@ƂĂȂAzdlɂȂĂ܂B
*/
class FODS_DOOR_UNIT
{
public:
	static const int iMaxToken = FODS_MAX_DOOR ;
	FODS_DOOR_UNIT()
		{ Clear() ; }
	~FODS_DOOR_UNIT(){;}

	void Clear()
		{ for(int i=0;i<iMaxToken;i++)Token[i].Clear(); CorrectSelectValue(); }
	int  Add( int iX , int iY , int iT )
	{
		return Add( iX , iY , iT , 0 , 0 , 0 , 0 ) ;
	}
	int  Add( int iX , int iY , int iT , int iDestR , int iDestP , int iDestX , int iDestY ) ;
	void Select( int iSuffix , int iSingle ) ;
	void Deselect( int iSuffix ) ;

	void SelectSwitch( int iSuffix ) ;

	void SelectAll()
		{for( int i=0 ; i<iMaxToken ; i++ ){Token[i].Select();  } CorrectSelectValue(); }
	void DeselectAll()
		{for( int i=0 ; i<iMaxToken ; i++ ){Token[i].Deselect();} CorrectSelectValue(); }

	void Delete( int iSuffix )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].Delete();CloseToken();}
	void Modify( int iSuffix , int iX , int iY , int iT , int iDestR , int iDestP , int iDestX , int iDestY )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].Modify(iX,iY,iT,iDestR,iDestP,iDestX,iDestY);}
	void ModifyDelta( int iSuffix , int iX , int iY , int iT )
		{assert(iSuffix>=0&&iSuffix<iMaxToken);Token[iSuffix].ModifyDelta(iX,iY,iT);}

	int GetType()
	{
		if( iSelected < 0 ){ return -1 ; }
		return Token[iSelected].GetT() ;
	}
	int GetDestValue( int *piDestR , int *piDestP , int *piDestX , int *piDestY )
	{
		if( iSelected < 0 ){ return 0 ; }
		if( piDestR ){ *piDestR = Token[iSelected].GetDestR() ; }
		if( piDestP ){ *piDestP = Token[iSelected].GetDestP() ; }
		if( piDestX ){ *piDestX = Token[iSelected].GetDestX() ; }
		if( piDestY ){ *piDestY = Token[iSelected].GetDestY() ; }
		return 1 ;
	}
	//ȉ̃I[o[[hꂽ֐͑Iꂽ̂ɍp
	void Delete()
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected()){Delete(i);i--;}}
	void Modify( int iX , int iY , int iT , int iDestR , int iDestP , int iDestX , int iDestY )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected())Modify(i,iX,iY,iT,iDestR,iDestP,iDestX,iDestY);}
	void ModifyDelta( int iX , int iY , int iT )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsSelected())ModifyDelta(i,iX,iY,iT);}

	void SetupImage( unsigned char *pucOut ) ;
	void ApplyImage( unsigned char *pucIn ) ;
	int SetupData( unsigned char **ppucOut , int iRoomW ) ;
	
	void InitEditing() ;
	int DoEdit( int iBaseX , int iBaseY ) ;
	void Draw( MyDIBObj3 *pMDO , int iSFC , int iBaseX , int iBaseY )
		{for( int i=0 ; i<iMaxToken ; i++ )if(Token[i].IsExist()){ Token[i].Draw( pMDO , iSFC , iBaseX , iBaseY ) ; }}
	int GetSelectedSuffix()
		{ return iSelected; }
private:
	FODS_DOOR Token[iMaxToken] ;
	int iSelected ;
	int iDragging ;
	int iDragPreX , iDragPreY ;
	void CloseToken() ;
	void CorrectSelectValue() ;
	int  SeekUnusedToken() ;
	int  SeekByPosition( int iX , int iY ) ;
	int DoEdit_Sub0( int iBaseX , int iBaseY ) ;
	int DoEdit_Sub1( int iBaseX , int iBaseY ) ;
	void InitDrag( int iX , int iY )
	{
		iDragging = 1 ;
		iDragPreX = iX ;
		iDragPreY = iY ;
	}
};

#endif











#endif /*FODS_P_TOKEN_UNIT_HEADER_INCLUDED*/

