

int FODS_TOKEN_UNIT::SeekByPosition( int iX , int iY )
{
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		if( Token[i].IsExist() &&
			Token[i].GetX() == iX &&
			Token[i].GetY() == iY )
		{
			return i ;
		}
	}
	return -1 ;
}
int FODS_TOKEN_UNIT::SeekUnusedToken()
{
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		if( !Token[i].IsExist() )
			{return i ;}
	}
	return -1 ;
}

void FODS_TOKEN_UNIT::Select( int iSuffix , int iSingle )
{
	if( iSingle )
		{ DeselectAll() ; }
	Token[ iSuffix ].Select() ;
	CorrectSelectValue();
}
void FODS_TOKEN_UNIT::Deselect( int iSuffix )
{
	Token[ iSuffix ].Deselect() ;
	CorrectSelectValue();
}

void FODS_TOKEN_UNIT::CorrectSelectValue()
{
	int iTmp = -1 ;
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		if( Token[i].IsSelected() )
		{
			if( iTmp>=0 )
			{
				iSelected = -2 ;
				return ;
			}
			iTmp = i ;
		}
	}
	iSelected = iTmp ;
	return ;
}

void FODS_TOKEN_UNIT::ApplyImage( unsigned char *pucIn )
{
	for( int i=0 ; i<iMaxToken ; i++ )
	{
		Token[i].ApplyImage( pucIn+i*FODS_BYTE_P_OBJECT ) ;
	}
}
void FODS_TOKEN_UNIT::CloseToken()
{
	int q=0 ;
	for( int i=q=0 ; i<iMaxToken ; i++ )
	{
		if( Token[i].IsExist() )
		{
			if( i != q )
			{
				Token[q] = Token[i] ;
				Token[i].Delete() ;
			}
			q++;
		}
	}
	CorrectSelectValue() ;
}
void FODS_TOKEN_UNIT::InitEditing()
{
	iDragging = 0 ;
	DeselectAll() ;
}
int FODS_TOKEN_UNIT::DoEdit( int iBaseX , int iBaseY )
{
	if( !iDragging ) return DoEdit_Sub0( iBaseX , iBaseY ) ;
	return DoEdit_Sub1( iBaseX , iBaseY ) ;
}
int FODS_TOKEN_UNIT::DoEdit_Sub0( int iBaseX , int iBaseY )
{
	int iRV = 0 ;
	int mx , my ;
	mx = GetMousePosX() - iBaseX ;
	my = GetMousePosY() - iBaseY ;
	mx = GaussDivision( mx , FODS_TILE_SIZE ) ;
	my = GaussDivision( my , FODS_TILE_SIZE ) ;

	if( KeyOn( KC_CTRL ) && KeyPush( KC_A ) )
	{
		SelectAll() ;
		iRV = 1 ;
	}
	if( KeyPush( KC_DEL ) )
	{
		Delete() ;
		iRV = 1 ;
	}
	if( MousePush( MB_L ) )
	{
		int iDest ;
		iDest = SeekByPosition( mx , my ) ;
		if( iDest < 0 )
		{ //UFI/zu
			if( KeyOn( KC_SHIFT ) )
			{
				InvalidateMouse() ;
				int cX , cY , cT ;
				cX = mx ;
				cY = my ;
				cT = 0 ;
				if( iSelected >= 0 )
				{
					cT = Token[ iSelected].GetT() ;
				}
				int iNew ;
				iNew = Add( cX , cY , cT ) ;
				if( iNew >= 0 )
				{
					Select( iNew , true ) ;
					InitDrag( mx , my ) ;
				}
				iRV = 1 ;
			}
			else if( !KeyOn( KC_CTRL ) )
			{ //VtgRg[ĂȂƂ͑SI
				DeselectAll() ;
				iRV = 1 ;
			}
		}
		else
		{ //Is
			assert( Token[iDest].IsExist() ) ;
			InvalidateMouse() ;
			if( KeyOn( KC_CTRL ) )
			{ //IorIXCb`
				if( Token[iDest].IsSelected() )
				{ //I
					Deselect( iDest ) ;
					iRV = 1 ;
				}
				else
				{ //ǉI
					Select( iDest , false ) ;
					InitDrag( mx , my ) ;
					iRV = 1 ;
				}
			}
			else
			{ //PI
				if( !Token[iDest].IsSelected() )
				{
					Select( iDest , true ) ;
				}
				InitDrag( mx , my ) ;
				iRV = 1 ;
			}
		}
	}
	return iRV ;
}

int FODS_TOKEN_UNIT::DoEdit_Sub1( int iBaseX , int iBaseY )
{//hbȌ
	if( !MouseOn( MB_L ) )
	{
		iDragging = 0 ;
		return 0 ;
	}
	int iRV = 0 ;
	int mx , my ;
	int dx , dy ;
	mx = GetMousePosX() - iBaseX ;
	my = GetMousePosY() - iBaseY ;
	mx = GaussDivision( mx , FODS_TILE_SIZE ) ;
	my = GaussDivision( my , FODS_TILE_SIZE ) ;
	dx = mx - iDragPreX ;
	dy = my - iDragPreY ;
	if( dx || dy )
	{
		ModifyDelta( dx , dy , 0 ) ;
		InitDrag( mx , my ) ;
		iRV = 1 ;
	}

	return iRV ;
}
