#include "common.h"

#include <direct.h>
#include <math.h>
#include "FileManager.h"
#include "packingEX.h"
#include "TextIO.h"



//O[ouvȊO
LPCTSTR GL::COMMON_CONST_WINDOW_CLASS_NAME   = _T("DREAM_TOOL_WCN") ;
LPCTSTR GL::COMMON_CONST_DEFAULT_WINDOW_TEXT = _T("Dream Tool") ;
LPCTSTR GL::ROM_NAME     = _T("kirby.nes") ;
LPCTSTR GL::ROM_OUT_NAME = _T("output.nes") ;
LPCTSTR GL::PATH_FILE_SETTING_TXT = _T("_setting.txt") ;
LPCTSTR GL::FILE_PATH_FCPAL = _T( "data\\fc.pal" ) ;
LPCTSTR GL::FILE_NAME_ROOM_H = _T( "room" ) ;
LPCTSTR GL::FILE_NAME_ROOM_F = _T( ".txt" ) ;

#define EXT_FODSCLIP _T("fodsclip")
LPCTSTR GL::FILE_NAME_CLIP = _T("clipped.") EXT_FODSCLIP ;
LPCTSTR GL::FILE_NAME_CLIP_EXT = EXT_FODSCLIP ;
LPCTSTR GL::FILE_NAME_CLIP_EXT_ = _T(".") EXT_FODSCLIP ;
#undef EXT_FODSCLIP
LPCTSTR GL::FILE_PATH_OBJNAME = _T("data\\ObjName.txt") ;
LPCTSTR GL::FILE_PATH_DOORNAME = _T("data\\DoorName.txt") ;
LPCTSTR GL::FILE_PATH_OUTPUT = _T("_Output.txt") ;
LPCTSTR GL::FILE_PATH_OUTPUT_SENV = _T("_Output_s.txt") ;
LPCTSTR GL::FILE_PATH_OUT_NES     = _T("_cmp.nes") ;



LPCTSTR GL::TEXT_SETTING_DEFAULT =
_T(";DreamTool project configuration file\n")
_T(";\n")
_T(";Neo website\n")
_T(";http://borokobo.web.fc2.com/neo/index.html\n")
_T(";Annex (Kirby)\n")
_T(";http://www4.atpages.jp/borokobo/index.html\n")
_T(";\n")
_T(";This file determines compilation options.\n")
_T(";Save all modifications before compiling\n")
_T(";\n")
_T(";\n")
_T(";Lines begining with semicolon (;) are comments\n")
_T("\n")
_T("\n")
_T("\n")
_T("#POOL_UNUSED_ROOM 0001\n")
_T("\n")
_T("#POOL_UNUSED_PRG_EDGE 0001\n")
_T("\n")
_T(";All doors pool objects\n")
_T("#POOL_DOOR 0000\n")
_T("\n")
_T("\n")
/*
_T(";\n")
_T(";@\n")
_T("#***\n")
_T("\n")
_T("\n")
*/
;


//O[oϐ
HWND GL::hWnd;
HINSTANCE GL::hInstance;
MyDIBObj3 GL::mdo( MAXSFC , WINWIDTH , WINHEIGHT );
TASKHANDLE GL::HAM ;
#ifdef _DEBUG
int GL::WINWIDTH     = 1024 ;
int GL::WINHEIGHT    = 800 ;
#else
int GL::WINWIDTH     = 780 ;
int GL::WINHEIGHT    = 580 ;
#endif

BYTE *GL::pucRom ;
int GL::iRomSize ;
int GL::iPrgSize ;
BMPD GL::NESColor[0x40] ;
FODS *GL::pFODSW ;
FODS *GL::pFODSS ;
tstring GL::strAppPath ;
tstring GL::strProjectPath ;
tstring GL::strRoomPath ;
int GL::iCurRoom ;
int GL::iDrawMode ;
int GL::iUpdatedRoom ;
tstring GL::astrObjectName[ 256 ] ;
tstring GL::astrDoorName[ 128 ] ;


//[Jϐ
TASKHANDLE GL::handle_frame_end = 0 ;


#define ADDR_REVIVAL_POS	0x1284D1 //
#define ADDR_ROOM_BANK		0x1284D1 //̂Q͓
#define ADDR_ROOM_ADHI		0x12875F
#define ADDR_ROOM_ADLO		0x1288A6
#define ADDR_OBJ_BANK		0x128A80
#define ADDR_OBJ_ADHI		0x128BC7
#define ADDR_OBJ_ADLO		0x128D0E

#define ADDR2OFFSET(addr)	((((addr)>>16)*0x2000)+((addr)&0x1FFF))

int GL::AppPrepare(HWND hwnd , HINSTANCE hinstance)
{
	Task0810 *Ptmp ;

	Ptmp = new TaskAppManager( NULL , TP_APP_MANAGER , true ) ;
	HAM = Ptmp->GetHandle() ;

	return 0;
}
int GL::AppRelease()
{
	return 0;
}





void GL::MainRoutine(int fps)
{
	Task0810 *Ptask ;
	Ptask = Task0810::SolveHandle( HAM ) ;
	if( Ptask )Ptask->DoCN() ;
	else DestroyWindow( hWnd ) ;
}



bool GL::CheckFE()
{
	if( !handle_frame_end )
	{	
		Task0810 *Pptr ;
		Pptr = Task0810::SolveHandle( HAM ) ;
		if( !Pptr )return false ;
		handle_frame_end = Pptr->SearchTask( TP_FRAMEEND ) ;
		if( !handle_frame_end )return false ;
	}
	return true ;
}
void GL::RequestRedraw()
{
	if( !CheckFE() )return ;
	Task0810 *Pptr ;
	Pptr = Task0810::SolveHandle( handle_frame_end ) ;
	if( !Pptr )return ;
	((TaskFrameEnd*)Pptr)->RequestRedraw() ;
}
void GL::RequestFlip()
{
	if( !CheckFE() )return ;
	Task0810 *Pptr ;
	Pptr = Task0810::SolveHandle( handle_frame_end ) ;
	if( !Pptr )return ;
	((TaskFrameEnd*)Pptr)->RequestFlip() ;
}



int GL::SafeRomLoad()
{
	tstring strFilename = GL::strAppPath ;
	strFilename += GL::ROM_NAME ;

	GL::pucRom = NULL ;
	GL::iRomSize = LoadMemoryFromFile( strFilename.c_str() , &GL::pucRom ) ;
	if( GL::iRomSize < 0 )
	{
		_TCHAR acBuf[GL::PATH_SIZE*2] ;
		_stprintf( acBuf , _T("%sCannot open ROM file") , strFilename.c_str() ) ;
		MessageBox( GL::hWnd , acBuf ,  _T("Error") , MB_OK ) ;
		return -1 ;
	}

	{
		bool onerror = false ;
		if( GL::iRomSize != GL::DEFAULT_ROM_SIZE )
		{
				MessageBox( GL::hWnd , _T("The size of the ROM is abnormal") , _T("Error") , MB_OK ) ;
				onerror = true ;
		}
		else
		{
			unsigned int eh = EHash( GL::pucRom , GL::iRomSize ) ;
			if( eh != GL::EHASH_OF_AUTHOR )
			{
				_TCHAR str[256] ;
				_stprintf_s( str , sizeof(str) , _T("ROM Hash is different as the original:%06X\n Loaded ROM hash:%06X\nROM") , GL::EHASH_OF_AUTHOR , eh ) ;
				MessageBox( GL::hWnd , str , _T("Error") , MB_OK ) ;
				onerror = true ;
			}
		}
		if( onerror )
		{
			int ans ;
			ans = MessageBox( GL::hWnd , _T("Are you sure you want to continue?") , _T("ROM Hash different")  , MB_YESNO ) ;
			if( ans == IDNO )
			{
				return -2 ;
			}
		}
	}
	return 0 ;
}

void GL::InitNameTable( LPTSTR *APdest )
{
	for( int i=0 ; i<256 ; i++ )
	{
		if( APdest[i] )free( APdest[i] ) ;
		APdest[i] = (LPTSTR)malloc( 2 ) ;
		memcpy( APdest[i] , "" , 2 ) ;
	}
}
int GL::LoadNameTable( LPTSTR *APdest , LPCTSTR filename )
{
FILE *fp ;
	if( _tfopen_s( &fp , filename  , _T("rt") ) )
	{
		return -1 ;
	}
	for(;;)
	{
		_TCHAR buf[512] ;
		if( !_fgetts( buf , 512 , fp ) )break ;
		if( buf[_tcslen(buf)-1]==_T('\n') )
			buf[_tcslen(buf)-1]=_T('\0') ;
		if( buf[0] != _T('#') )continue ;

		int number ;
		_TCHAR name[512] ;
		if( _stscanf_s( buf , _T("#%2X %64s") , &number , name , _countof(name) ) == 2 && number>=0 && number<256 )
		{
			if( APdest[number] )free( APdest[number] ) ;
			APdest[number] = (LPTSTR)malloc( _tcslen(name)+1 ) ;
			_tcscpy_s( APdest[number] , _tcslen(name)+1 , name ) ;
		}
	}
	fclose( fp ) ;
	return 0 ;
}
int GL::LoadNameTable( tstring *pstrDest , int iSize , LPCTSTR filename )
{
FILE *fp ;
	if( _tfopen_s( &fp , filename  , _T("rt") ) )
	{
		return -1 ;
	}
	for(;;)
	{
		_TCHAR buf[512] ;
		if( !_fgetts( buf , 512 , fp ) )break ;
		if( buf[_tcslen(buf)-1]==_T('\n') )
			buf[_tcslen(buf)-1]=_T('\0') ;
		if( buf[0] != _T('#') )continue ;

		int number ;
		_TCHAR name[512] ;
		if( _stscanf_s( buf , _T("#%2X %64s") , &number , name , _countof(name) ) == 2 && number>=0 && number<iSize )
		{
			pstrDest[number] = name ;
		}
	}
	fclose( fp ) ;
	return 0 ;
}


static double sinline( double arg )
{
	if( arg > 1)arg -= (int)arg;
	if( arg > 0.6666 )return 0;
	return sin( arg/0.6666*3.141592);
}

void GL::SetupNESColor( LPCTSTR filename )
{
	{//vZłȂeLg[ȃpbg쐬
		int i;
		for( i=0 ; i<3 ; i++ ) NESColor[i*16] = myRGB(i*6+17,i*6+17,i*6+17);
		NESColor[0x30] = NESColor[0x20] ;

		//Wikipedia HSVF
		//ja.wikipedia.org/wiki/HSV%E8%89%B2%E7%A9%BA%E9%96%93
		//NTSCMɑΉ悤ȂƗǂ@̂낤H

		//SṼe[uAeLg[ł
		static double STable[4] = {1.0,1.0,0.8,0.5} ;
		static double VTable[4] = {0.5,0.7,0.9,1.0} ;
		for( int iC=0 ; iC<12 ; iC++ )
		{
		for( int iB=0 ; iB<4 ; iB++ )
		{
			double r,g,b ;
			double H,S,V ;
			int Hi ;
			double f , p , q , t ;
			H = ( 360+210+iC*30 ) % 360 ;
			S = STable[iB] ;
			V = VTable[iB] ;
			Hi = (int)(H/60)%6 ;
			f = H/60 - Hi ;
			p = V * ( 1 - S ) ;
			q = V * ( 1 - f * S ) ;
			t = V * ( 1 - ( 1 - f ) * S ) ;
			switch( Hi )
			{
			case 0:
				r=V; g=t ; b=p ;
			break ;
			case 1:
				r=q; g=V ; b=p ;
			break ;
			case 2:
				r=p; g=V ; b=t ;
			break ;
			case 3:
				r=p; g=q ; b=V ;
			break ;
			case 4:
				r=t; g=p ; b=V ;
			break ;
			case 5:
				r=V; g=p ; b=q ;
			break ;
			}
			NESColor[1+iC+iB*16] = 
				myRGB(
				(min( (int)(r*31+0.5) , 31 ))
				,
				(min( (int)(g*31+0.5) , 31 ))
				,
				(min( (int)(b*31+0.5) , 31 ))
				);
		}
		}
	}
	{//pbgt@Cǂݏo
		tstring strFilename( strAppPath ) ;
		strFilename += filename ;

		FILE *fp ;
		if( !_tfopen_s( &fp , strFilename.c_str() , _T("rb") ) )
		{
			BYTE buf[3*64] ;
			if( fread( buf , 1 , 3*64 , fp ) == 3*64 )
			{
	int r,g,b;
	int i;
				for( i=0 ; i<64 ; i++ )
				{
					r = buf[i*3+0] ;
					g = buf[i*3+1] ;
					b = buf[i*3+2] ;
					r >>= 3;
					g >>= 3;
					b >>= 3;
					NESColor[i] = (r<<10) | (g<<5) | b ;
				}
			}
			fclose( fp ) ;
		}
	}
}


void GL::DropRoutine(WPARAM wp)
{
Task0810 *Ptmp ;

HDROP hd;
_TCHAR fn[512];
int  NOfile;
	//nh𓾂
	hd = (HDROP) wp;

	//łɁA^XN𒲂ׂĂ
	Ptmp = Task0810::SolveHandle(HAM) ;
	if( !Ptmp )
	{//C^XN݂ĂȂ̂ŁAǂłȂ
		assert(0) ;
		DragFinish( hd );
		return ;
	}
	//hbvꂽt@C擾
	NOfile = DragQueryFile( hd , 0xFFFFFFFF , NULL , 0 );
	if( NOfile >= 2 )
	{
		new TaskObjectBoxText( Ptmp , false , 0 , 0 , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
				_T("Qȏ̃t@C͓Ƀhbvł܂") , 150 ) ;
		DragFinish( hd );
		return ;
	}
	DragQueryFile( hd , 0 , fn , sizeof(fn) );
	DragFinish( hd );
//[hmF
	TASKHANDLE hMM ;
	Task0810 *pMM ;
#define EXT_CHECK(ext)			(!_tcscmp( (ext) , &fn[_tcslen(fn)-_tcslen(ext)] ))

	if( Ptmp->SearchTask( TP_PROJECT_PATH_MODE ) )
	{//vWFNgpX[hFvWFNgpX̎t
		//fQhbvĂȎɂȂȂ悤ɂĂB
		if( _T("") != GL::strProjectPath ){return;}

		//܂łɕ\Ăx\폜
		Ptmp->KillP( TP_BOX_TEXT , TP_BOX_TEXT ) ;

		tstring strBase ;
		strBase = fn ;
		if( !MyPathIsDirectory( strBase.c_str() ) )
		{
			tstring strTmp ;
			strTmp = strBase ;
			strTmp += _T("\nThis is not a folder...") 
				_T("\nPlease drop a folder.") ;
			new TaskObjectBoxText( Ptmp , false , 
				0 , 0 , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
				strTmp.c_str() , 240 ) ;
			return ;
		}
		//Ō\\tĂ
		if( strBase.at( strBase.size()-1 ) != _T('\\') )
		{
			strBase += _T('\\') ;
		}

		tstring strPathSetting = strBase ;
		strPathSetting += GL::PATH_FILE_SETTING_TXT ;
		if( MyFileIsExists( strPathSetting .c_str() ) )
		{
			tstring strTmp ;
			strTmp = GL::PATH_FILE_SETTING_TXT ;
			strTmp += _T("This is a project configuration file.") ;
			new TaskObjectBoxText( Ptmp , false , 
				0 , 0 , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
				strTmp.c_str() , 240 ) ;

			//vWFNg̃pX
			GL::strProjectPath = strBase ;
			return ;
		}
		//vWFNgVK쐬
		{//bZ[W\
			new TaskObjectBoxText( Ptmp , false , 
				0 , 0 , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
				_T("It will create a new project") , 240 ) ;
		}
		{//ZbeBOt@C̍쐬
			tofstream ofSetting( strPathSetting.c_str() ) ;
			ofSetting.imbue( locale( "japanese" , LC_CTYPE ) ) ;
			if( ofSetting.bad() )
			{
				tstring strTmp(strPathSetting) ;
				strTmp += _T("Failed to create project") ;
				new TaskObjectBoxText( Ptmp , false , 
					0 , 14*1 , 14 , 7 , RGB(0,0,0) , RGB(255,255,255) ,
					strTmp.c_str() , 240 ) ;
				return ;
			}
			ofSetting << GL::TEXT_SETTING_DEFAULT << endl ;
		}
/*		{//tH_쐬
			tstring strPathDir = strBase ;
			strPathDir += GL::PATH_DIR_ROOM ;
			_tmkdir( strPathDir.c_str() ) ;
			strPathDir = strBase ;
			strPathDir += GL::PATH_DIR_CHIP ;
			_tmkdir( strPathDir.c_str() ) ;
		}
*/

		//vWFNg̃pX
		GL::strProjectPath = strBase ;
		return ;
	}
	else if( ( hMM = Ptmp->SearchTask( TP_MODE_MANAGER ) ) && ( pMM = Task0810::SolveHandle(hMM) ) )
	{//[h}l[WF[hɂ蕪
		if( pMM->SearchTask( TP_MODE_MAP ) )
		{ //}bv[hFNbvt@C̎t
			if( EXT_CHECK( GL::FILE_NAME_CLIP_EXT_ ) )
			{
				GL::pFODSW->pVTE->LoadClipFile( fn ) ;
				GL::RequestRedraw() ;
			}
		}
	}





#undef EXT_CHECK
}

void GL::LoadRoom( FODS *pFODS , int iRoom )
{
	tstring strFilename = GetFODSFileName( iRoom ) ;
	pFODS->Clear() ;

	if( iRoom>=0 && iRoom<FODS_MAX_ROOM )
	{
		pFODS->LoadRoomFromROM( iRoom ) ;
		if( MyFileIsExists( strFilename.c_str() ) )
		{
			pFODS->Load( strFilename.c_str() ) ;
		}
	}
	pFODS->SetVTEWindow() ;
}

tstring GL::GetFODSFileName( int iRoom )
{
	tstring strFilename( strProjectPath ) ;
	_TCHAR atcD[16] , atcH[16] ;
	_stprintf_s( atcD , _countof(atcD) , _T("%03d") , iRoom ) ;
	_stprintf_s( atcH , _countof(atcD) , _T("%03X") , iRoom ) ;
	strFilename += FILE_NAME_ROOM_H ;
	strFilename += atcD ;
	strFilename += _T( "[" ) ;
	strFilename += atcH ;
	strFilename += _T( "]" ) ;
	strFilename += FILE_NAME_ROOM_F ;

	return strFilename ;
}
int GL::Compile()
{
	int iReturnValue = 1 ;
	unsigned char *aucNewROM ;
	unsigned char *aucFree ;
	int iPoolField[FODS_MAX_ROOM] = {0} ;
	int iPoolObj  [FODS_MAX_ROOM] = {0} ;
	int iPoolDoor [FODS_MAX_ROOM] = {0} ;
	unsigned char aucRevivePos[FODS_MAX_ROOM] = {0} ;

	int iSetting_PoolUnusedRoom    = 1 ;
	int iSetting_PoolUnusedPrgEdge = 1 ;
	int iSetting_PoolAllDoor       = 0 ;

	tstring strFileName( GL::strProjectPath ) ;
	strFileName += GL::FILE_PATH_OUTPUT ;
	tofstream Output( strFileName.c_str() ) ;
	strFileName =  GL::strProjectPath  ;
	strFileName += GL::FILE_PATH_OUTPUT_SENV ;
	tofstream Output_s( strFileName.c_str() ) ;

	try
	{
		PackingEX PackEX ;

		DebugOut( Output , Output_s , 1 , _T("Starting compilation...") ) ;
		SetWindowText( GL::hWnd , _T("Starting compilation...") ) ;
		{
			tstring strPathSetting = GL::strProjectPath ;
			strPathSetting += GL::PATH_FILE_SETTING_TXT ;
			tstring strMessage( _T("Compilation settings(") ) ;
			strMessage += PATH_FILE_SETTING_TXT ;
			strMessage += _T(")Read") ;
			DebugOut( Output , Output_s , 1 , strMessage.c_str() ) ;
			TextIOManager tiom( strPathSetting.c_str() , 128 , _T('#') , _T(';') ) ;
			tiom.AddIOItem_16Value( _T("POOL_UNUSED_ROOM")     , &iSetting_PoolUnusedRoom ) ;
			tiom.AddIOItem_16Value( _T("POOL_UNUSED_PRG_EDGE") , &iSetting_PoolUnusedPrgEdge ) ;
			tiom.AddIOItem_16Value( _T("POOL_DOOR")            , &iSetting_PoolAllDoor ) ;


			tiom.DoLoading() ;
		}
		DebugOut( Output , Output_s , 1 , _T("Memory allocation(aucNewROM,aucFree)") ) ;
		aucNewROM = (unsigned char * )malloc( GL::iRomSize ) ;
		aucFree   = (unsigned char * )malloc( GL::iRomSize ) ;
		if( !aucNewROM || !aucFree )
		{ //mێs@ƂȂƂĂ]TƎvꉞ
			DebugOut( Output , Output_s , 1 , _T("Failed to allocate memory") ) ;
			throw 0 ;
		}
		memcpy( aucNewROM , GL::pucRom , GL::iRomSize ) ;
		memset( aucFree , 0 , GL::iRomSize ) ;

		{
			unsigned char *(apDoorData[FODS_MAX_ROOM]) ;
			for( int i=0 ; i<FODS_MAX_ROOM ; i++ )
				{ apDoorData[i] = NULL ; }
			try
			{
				DebugOut( Output , Output_s , 1 , _T("Ready to write the data of the room") ) ;

				FODS FODSWork( NULL , NULL , 0 , 0 , 0 , aucNewROM , GL::iRomSize , 0 ) ;
				int iTower = 0 ;
				int iRaster = 0 ;
				int iStatus1 = 0 ;
				int iStatus2 = 0 ;
				int aiDoorPoolAddr[FODS_MAX_ROOM] ;
				int aiDoorPoolSize[FODS_MAX_ROOM] ;
				int aiDoorPoolUserOrg[FODS_MAX_ROOM] ;
				int aiDoorPoolUsers[FODS_MAX_ROOM] ;
				int iCurrentDoorPoolNumber ;
				int iMaxDoorPool ;
				unsigned char *(apDoorData[FODS_MAX_ROOM]) ;
				int aiDoorSize[FODS_MAX_ROOM] ;
				int aiDoorAllocatedPool[FODS_MAX_ROOM] ;

				iCurrentDoorPoolNumber = -1 ;
				iMaxDoorPool = 0 ;
				for( int iRoom=0 ; iRoom<FODS_MAX_ROOM ; iRoom++ )
				{
					{
						_TCHAR atcTmp[128] ;
						_stprintf_s( atcTmp , _countof(atcTmp) , _T("%03d[%03x]") , iRoom , iRoom ) ; 
						DebugOut( Output , Output_s , 0 , atcTmp ) ;
						_stprintf_s( atcTmp , _countof(atcTmp) , _T("Compiling...Room:%03d[%03X]/%03d[%03X]") , iRoom , iRoom , FODS_MAX_ROOM , FODS_MAX_ROOM ) ;
						SetWindowText( GL::hWnd , atcTmp ) ;
					}
					LoadRoom( &FODSWork , iRoom ) ;
					if( FODSWork.IsFieldPooled() )
					{
						unsigned char *pucTmp ;
						int iSize ;
						iSize = FODSWork.SetupRoomData( &pucTmp ) ;
						if( iSize <= 0 )
						{
							DebugOut( Output , Output_s , 1 , _T("Failed to prepare map data") ) ;
							throw 0 ;
						}
						PackEX.Register( pucTmp , iSize , true , 
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_ROOM_ADLO + iRoom ) ,
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_ROOM_ADHI + iRoom ) ,
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_ROOM_BANK + iRoom ) ,
											NULL ) ;
						int iDefAddr , iDefSize ;
						FODSWork.GetDefaultFieldSpace( &iDefAddr , &iDefSize ) ;
						memset( aucFree + 0x10 + ADDR2OFFSET( iDefAddr ) , 1 , iDefSize ) ;
						iPoolField[iRoom] = 1 ; 
						{	_TCHAR atcTmp[128] ;
							_stprintf_s( atcTmp , _countof(atcTmp) , _T("Map:write/%X pool/%X") , iSize , iDefSize ) ;
							DebugOut( Output , Output_s , 0 , atcTmp ) ; 
						}
					}
					if( FODSWork.IsObjPooled() )
					{
						unsigned char *pucTmp ;
						int iSize ;
						iSize = FODSWork.SetupObjData( &pucTmp ) ;
						if( iSize <= 0 )
						{
							DebugOut( Output , Output_s , 1 , _T("Failed to prepare object data") ) ;
							throw 0 ;
						}
						PackEX.Register( pucTmp , iSize , true , 
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_OBJ_ADLO + iRoom ) ,
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_OBJ_ADHI + iRoom ) ,
											aucNewROM + 0x10 + ADDR2OFFSET( ADDR_OBJ_BANK + iRoom ) ,
											NULL ) ;
						int iDefAddr , iDefSize ;
						FODSWork.GetDefaultObjSpace( &iDefAddr , &iDefSize ) ;
						memset( aucFree + 0x10 + ADDR2OFFSET( iDefAddr ) , 1 , iDefSize ) ;
						iPoolObj  [iRoom] = 1 ;
						{	_TCHAR atcTmp[128] ;
							_stprintf_s( atcTmp , _countof(atcTmp) , _T("Object: write/%X pool/%X") , iSize , iDefSize ) ;
							DebugOut( Output , Output_s , 0 , atcTmp ) ; 
						}
					}

					aiDoorAllocatedPool[ iRoom ] = -1 ;
					if( FODSWork.IsDoorPooled() )
					{
						int iDefAddr , iDefSize ;
						FODSWork.GetDefaultDoorSpace( &iDefAddr , &iDefSize ) ;
						if( iCurrentDoorPoolNumber < 0 )
						{ //VKhAv[
							iCurrentDoorPoolNumber = iMaxDoorPool ;
							iMaxDoorPool ++ ;
							aiDoorPoolAddr[ iCurrentDoorPoolNumber ] = iDefAddr ;

							aiDoorPoolSize[ iCurrentDoorPoolNumber ] = iDefSize ;
							aiDoorPoolUsers[ iCurrentDoorPoolNumber ] = 1 ;
							aiDoorPoolUserOrg[ iCurrentDoorPoolNumber ] = iRoom ;
						}
						else
						{ //ÕhAv[ƌq
							aiDoorPoolSize[ iCurrentDoorPoolNumber ] += iDefSize ;
							aiDoorPoolUsers[ iCurrentDoorPoolNumber ] ++ ;
						}
						aiDoorAllocatedPool[ iRoom ] = iCurrentDoorPoolNumber ;
						//hAf[^
						if( ( aiDoorSize[ iRoom ] = FODSWork.SetupDoorData( &(apDoorData[ iRoom ]) ) ) < 0 )
						{
							DebugOut( Output , Output_s , 1 , _T("Failed to prepare room data") ) ;
							throw 0 ;
						}
						iPoolDoor [iRoom] = 1 ;
					}
					if( !FODSWork.IsDoorPooled() || iRoom==FODS_MAX_ROOM-1 )
					{//P̃hAv[I
						iCurrentDoorPoolNumber = -1 ;
					}
					
					if( iPoolField[iRoom] | iPoolObj[iRoom] | iPoolDoor[iRoom] )
					{}
					else
					{ //؂̃v[
						if( iSetting_PoolUnusedRoom )
						{//gp̃v[
							static const unsigned char TableUnunsedRoom[] =
							{
		0,0,0,0,0,0,0,1, 0,0,0,0,0,0,0,0,
		0,0,0,0,1,1,1,1, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 1,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,

		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,1,1, 0,1,1,1,1,1,1,1,
		1,1,1,1,1,1,1,
							} ;
							if( TableUnunsedRoom[iRoom] )
							{ 
								int iDefAddr , iDefSize1 , iDefSize2 ;
								FODSWork.GetDefaultFieldSpace( &iDefAddr , &iDefSize1 ) ;
								memset( aucFree + 0x10 + ADDR2OFFSET( iDefAddr ) , 1 , iDefSize1 ) ;
								FODSWork.GetDefaultObjSpace( &iDefAddr , &iDefSize2 ) ;
								memset( aucFree + 0x10 + ADDR2OFFSET( iDefAddr ) , 1 , iDefSize2 ) ;
								{	_TCHAR atcTmp[128] ;
									_stprintf_s( atcTmp , _countof(atcTmp) , _T("Unused room pool map:%X Object:%X") , 
										iDefSize1 , iDefSize2 ) ;
									DebugOut( Output , Output_s , 0 , atcTmp ) ; 
								}

							}
						}
					}
					{ //p[^
						FODSWork.GetRoomParameter( NULL , NULL , NULL , NULL , NULL , NULL , NULL , NULL , 
													aucRevivePos+iRoom , NULL , NULL , NULL , NULL , NULL ) ;
						FODSWork.UpdateROM( iRoom , &iTower , &iRaster , &iStatus1 , &iStatus2 ) ;
						if( iTower==SIZE_SPROOM_TOWER+1 )
						{	_TCHAR atcTmp[128] ;
							iTower ++ ;
							_stprintf_s( atcTmp , _countof(atcTmp) , 
								_T("\"Tower\" flag data is set at more than %d\nIt will not work.") , SIZE_SPROOM_TOWER ) ;
							DebugOut( Output , Output_s , 1 , atcTmp ) ; 
						}
						if( iRaster==SIZE_SPROOM_RASTER+1 )
						{	_TCHAR atcTmp[128] ;
							iRaster ++ ;
							_stprintf_s( atcTmp , _countof(atcTmp) , 
								_T("\"Special scrolling\" data flag is set at more than %d\nIt will not work.") , SIZE_SPROOM_RASTER ) ;
							DebugOut( Output , Output_s , 1 , atcTmp ) ; 
						}
						if( iStatus1==SIZE_SPROOM_STATUS1+1 )
						{	_TCHAR atcTmp[128] ;
							iStatus1 ++ ;
							_stprintf_s( atcTmp , _countof(atcTmp) , 
								_T("\"Status color(01)\" data flag is set at more than%d\nIt will not work.") , SIZE_SPROOM_STATUS1 ) ;
							DebugOut( Output , Output_s , 1 , atcTmp ) ; 
						}
						if( iStatus2==SIZE_SPROOM_STATUS2+1 )
						{	_TCHAR atcTmp[128] ;
							iStatus2 ++ ;
							_stprintf_s( atcTmp , _countof(atcTmp) , 
								_T("\"Status color(02)\" data flag is set at more than%d\nIt will not work.") , SIZE_SPROOM_STATUS2 ) ;
							DebugOut( Output , Output_s , 1 , atcTmp ) ; 
						}
					}
				}
				{
					SetWindowText( GL::hWnd , _T("Compiling") ) ;
					DebugOut( Output , Output_s , 1 , _T("Writing door data") ) ;
					//o͂
					{
						_TCHAR atcTmp[128] ;
						{
							_stprintf_s( atcTmp , _countof(atcTmp) , _T("Door pool data is present (%d)") , iMaxDoorPool ) ;
							DebugOut( Output , Output_s , 1 , atcTmp ) ;
							for( int i=0 ; i<iMaxDoorPool ; i++ )
							{
								_stprintf_s( atcTmp , _countof(atcTmp) , _T("Door pool#%d  Room:%03X-%03X  %d doors") , 
									i , aiDoorPoolUserOrg[i] , aiDoorPoolUserOrg[i]+aiDoorPoolUsers[i]-1 , aiDoorPoolSize[i]/5 ) ;
								DebugOut( Output , Output_s , 0 , atcTmp ) ;
							}
						}
						for( int i=0 ; i<iMaxDoorPool ; i++ )
						{
#define ADDR_DOOR_BODY	0x12923B
#define ADDR_DOOR_ADLO	0x128F82
#define ADDR_DOOR_ADHI	0x1290CB

							for( int q=aiDoorPoolUserOrg[i] ; q<aiDoorPoolUserOrg[i]+aiDoorPoolUsers[i] ; q++ )
							{
								//eʓIɂǂłĂAAhX̓Zbg
								aucNewROM[ 0x10 + ADDR2OFFSET( ADDR_DOOR_ADLO ) + q ] = aiDoorPoolAddr[i] & 0xFF ;
								aucNewROM[ 0x10 + ADDR2OFFSET( ADDR_DOOR_ADHI ) + q ] = ((aiDoorPoolAddr[i] >> 8) & 0xFF ) ;
								if( aiDoorPoolSize[i] >= aiDoorSize[q] )
								{
									if( aiDoorSize[q] )
									{
										memcpy( aucNewROM + 0x10 + ADDR2OFFSET(aiDoorPoolAddr[i]) , apDoorData[q] , aiDoorSize[q] ) ;
									}
									aiDoorPoolAddr[i] += aiDoorSize[q] ;
									aiDoorPoolSize[i] -= aiDoorSize[q] ;
								}
								else
								{ //eʕs
									_stprintf_s( atcTmp , _countof(atcTmp) , _T("Door pool #%d is truncated : Door capacity overflow%03X") , i , q ) ;
									DebugOut( Output , Output_s , 1 , atcTmp ) ;
									if( aiDoorPoolSize[i] )
									{
										memcpy( aucNewROM + 0x10 + ADDR2OFFSET(aiDoorPoolAddr[i]) , apDoorData[q] , aiDoorPoolSize[i] ) ;
										aiDoorPoolAddr[i] += aiDoorPoolSize[i] ;
										aiDoorPoolSize[i]  = 0 ;
									}
								}
							}
							if( aiDoorPoolSize[i] )
							{ //hA]
								_stprintf_s( atcTmp , _countof(atcTmp) , _T("Door pool #%d overflow in %dProcessing speed may be reduced.") , i , aiDoorPoolSize[i]/5 ) ;
								DebugOut( Output , Output_s , 1 , atcTmp ) ;
								for( ; aiDoorPoolSize[i]>0 ; aiDoorPoolSize[i]-= 5 )
								{
									static const unsigned char aucTable[5] = {0x0F,0xFF , 0x00 , 0x00 , 0x00 } ;
									memcpy( aucNewROM + 0x10 + ADDR2OFFSET( aiDoorPoolAddr[i] ) , aucTable , 5 ) ;
									aiDoorPoolAddr[i] += 5 ;
									aiDoorPoolSize[i] -= 5 ;

								}
							}
						}
/*						for( int iDP=0 ; iDP<iMaxDoorPool ; iDP++ )
						{
							DebugOut( Output , Output_s , 1 , atcTmp ) ;
							for( int i=0 ; i<FODS_MAX_ROOM ; i++ )
							{
								if( aiDoorAllocatedPool[i] == iDP )
								{
									

								}

							}

						}
				unsigned char *(apDoorPool[FODS_MAX_ROOM]) ;
				int aiDoorPoolSize[FODS_MAX_ROOM] ;
				int iCurrentDoorPoolNumber ;
				int iMaxDoorPool ;
				unsigned char *(apDoorData[FODS_MAX_ROOM]) ;
				int aiDoorSize[FODS_MAX_ROOM] ;
				int aiDoorAllocatedPool[FODS_MAX_ROOM] ;
				*/
					}

				}
			}
			catch( int iErr )
			{
				for( int i=0 ; i<FODS_MAX_ROOM ; i++ )
				{
					if( apDoorData[i] ){ free(apDoorData[i]); }
				}
				throw iErr ;
			}
			//hAp̃NA
			for( int i=0 ; i<FODS_MAX_ROOM ; i++ )
			{
				if( apDoorData[i] ){ free(apDoorData[i]); }
			}
		}
		DebugOut( Output , Output_s , 1 , _T("Preparation of free space") ) ;
		{
			int iFreeBlockOrg = -1 ;
			for( int i=0x10 ; i<GL::iRomSize ; i++ )
			{//ہAROM̃TCY܂ŌKv͂Ȃ(̂قuqnl)
				if( aucFree[i] )
				{
					iFreeBlockOrg = i ;
					for( ; i<GL::iRomSize ; i++ )
					{//̏Ɩ[̋󂫗eʂ𓦂ccA̒ʂA[͂Ȃ炸pς݈ɂȂĂ
						if( !aucFree[i] || !((i-0x10)&0x1FFF) )
						{
							PackEX.RegisterFreeSpace( aucNewROM+0x10 , iFreeBlockOrg-0x10 , i - iFreeBlockOrg ) ;
							//oNÊPoCgڂ𓦂Ȃ悤ɂ
							if( aucFree[i] ){ i-- ; }
							break ;
						}
					}
				}
			}
			DebugOut( Output , Output_s , 0 , _T("Free space pooled")) ; 
			PackEX.OutputFreeSpaceInfo( Output_s ) ;
			DebugOut( Output , Output_s , 0 , _T("Value used is too large")) ; 
		}
		{
			DebugOut( Output , Output_s , 1 , _T("Packing files...") ) ;
			if( !PackEX.Do() )
			{
				DebugOut( Output , Output_s , 1 , _T("-Failed to pack") ) ;
				DebugOut( Output , Output_s , 0 , _T("Free space when you give up packing") ) ;
				PackEX.OutputFreeSpaceInfo( Output_s ) ;
				DebugOut( Output , Output_s , 0 , _T("The following data was left untreated") ) ;
				PackEX.OutputPackDataInfo( Output_s ) ;
				DebugOut( Output , Output_s , 0 , _T("Note: Total packed size (including free space) is larger than the size of raw data") ) ;
				DebugOut( Output , Output_s , 0 , _T("An error has occurred") ) ;
				//DebugOut( Output , Output_s , 0 , _T("@@@ł傫ȋ󂫗eʂA݃f[^Pł傫Ɣ܂B") ) ;
				//DebugOut( Output , Output_s , 0 , _T("@@@ł傫Ȗf[^̃TCY()ŁÃeLXgeLXgA") ) ;
				//DebugOut( Output , Output_s , 0 , _T("@@@ǂł̃f[^ꂽ肵Ȁꏊ̃f[^팸ĂB") ) ;
				throw 0 ;
			}
			DebugOut( Output , Output_s , 0 , _T("-Free space after packing" ) ) ; 
			PackEX.OutputFreeSpaceInfo( Output_s ) ;
		}
		{
			DebugOut( Output , Output_s , 1 , _T("Respawn point specification") ) ;
			for( int iRoom=0 ; iRoom<FODS_MAX_ROOM ; iRoom++ )
			{
				if( iPoolField[iRoom] | iPoolObj[iRoom] | iPoolDoor[iRoom] )
				{
					int iAddr = 0x10 + ADDR2OFFSET( ADDR_REVIVAL_POS+iRoom ) ;
					int iVal = ( aucNewROM[ iAddr ] & 0x7F ) ;
					if( aucRevivePos[iRoom] )
						{ iVal |= 0x80 ; }
					aucNewROM[ iAddr ] = iVal ;
				}
			}
		}
		{
			DebugOut( Output , Output_s , 1 , _T("Export") ) ;
			int iRV ;
			tstring strFileName( GL::strProjectPath ) ;
			strFileName += FILE_PATH_OUT_NES ;
			iRV = WriteFileFromMemory( strFileName.c_str() , aucNewROM , GL::iRomSize ) ;
			if( iRV )
			{
				DebugOut( Output , Output_s , 1 , _T("-Failed to write") ) ;
				throw 0 ;
			}
		}
	}
	catch( int iErr )
	{
		iErr ;
		DebugOut( Output , Output_s , 1 , _T("Failed to compile") ) ;
		iReturnValue = 0 ;
	}
	if( aucNewROM ){ free( aucNewROM ) ; }
	if( aucFree ){ free( aucFree ) ; }
	SetWindowText( GL::hWnd , _T("End of compilation process") ) ;
	return iReturnValue ;
}
void GL::DebugOut( tofstream &oOS1 , tofstream &oOS2 , int iSenv , LPCTSTR str )
{
	if( iSenv )
	{oOS1 << str << std::endl ; }
	oOS2 << str << std::endl ; 
}

/*
//ÓIɊmۂꂽA`bv`p̊֐B
//J͈͂LƂ܂߂Ă邪΂񂾓
void GL::DrawChipStatic( int iSFC , int iX , int iY , int iTileNo )
{
	int iCX , iCY ;
	iCX = iTileNo % 16 * FODS_TILE_SIZE ;
	iCY = iTileNo / 16 * FODS_TILE_SIZE ;
	mdo.Blt( MDO3WINAPI , iSFC , iX , iY , FODS_TILE_SIZE , FODS_TILE_SIZE , SFC_CHIP , iCX , iCY ) ;
}
*/


