#ifndef GLOBAL_CLASS_HEADER_INCLUDED
#define GLOBAL_CLASS_HEADER_INCLUDED

#include <windows.h> //MAX_PATH
#include <tchar.h>
#include "task0810.h"
#include "mydibobj3.h"
#include "TypedFunction.h"

#include "fods.h"




class GL
{
public:
//O[o萔
	static LPCTSTR COMMON_CONST_WINDOW_CLASS_NAME ;
	static LPCTSTR COMMON_CONST_DEFAULT_WINDOW_TEXT ;
	static LPCTSTR PATH_FILE_SETTING_TXT ;
	static LPCTSTR TEXT_SETTING_DEFAULT ;
	static LPCTSTR FILE_PATH_FCPAL ;
	static LPCTSTR FILE_NAME_ROOM_H ;
	static LPCTSTR FILE_NAME_ROOM_F ;
	static LPCTSTR FILE_NAME_CLIP ;
	static LPCTSTR FILE_NAME_CLIP_EXT ;
	static LPCTSTR FILE_NAME_CLIP_EXT_ ;
	static LPCTSTR FILE_PATH_OBJNAME ;
	static LPCTSTR FILE_PATH_DOORNAME ;
	static LPCTSTR FILE_PATH_OUTPUT ;
	static LPCTSTR FILE_PATH_OUTPUT_SENV ;
	static LPCTSTR FILE_PATH_OUT_NES ;

	static const int MAXSFC = 10 ;
	static const int MAXTASK = 200 ;

	static const int SFC_BACK     = 0 ;
	static const int SFC_CHAR     = 1 ;
	static const int SFC_CHIP     = 2 ;
	static const int SFC_HIT_INFO = 3 ;
	static const int SFC_CHAR_S   = 4 ;
	static const int SFC_CHIP_S   = 5 ;
	static const int SFC_DYNAMIC  = 6 ;

	static LPCTSTR ROM_NAME ;
	static LPCTSTR ROM_OUT_NAME ;
	static const int DEFAULT_ROM_SIZE = (256*1024*3+0x10) ;
	static const int EHASH_OF_AUTHOR = (0xC62DD4) ;

	static const int PATH_SIZE = MAX_PATH ; //FMAX_PATH́A[U[ɒ񋟂Ă萔ł͖ƌbBƂ肠At@C߂̂ɏ\傫ȖڈƂėpĂB

//O[oϐ
	static HWND hWnd;
	static HINSTANCE hInstance;
	static MyDIBObj3 mdo;
	static TASKHANDLE HAM ;
	static int WINWIDTH ;
	static int WINHEIGHT ;

	static BYTE *pucRom ;
	static int iRomSize ;
	static int iPrgSize ;

	static BMPD NESColor[0x40] ;

	static FODS *pFODSW ;
	static FODS *pFODSS ;
	static tstring strAppPath ;
	static tstring strProjectPath ;
	static tstring strRoomPath ;
	static int iCurRoom ;
	static int iDrawMode ;
	static int iUpdatedRoom ;

	static tstring astrObjectName[ 256 ] ;
	static tstring astrDoorName[ 128 ] ;

//O[o֐
	static int AppPrepare(HWND hwnd , HINSTANCE hinstance);
	static int AppRelease();
	static void MainRoutine(int fps);

	static void RequestRedraw();
	static void RequestFlip();

	static void KageMoji( int sfc , LPCTSTR str , int x , int y , int h , int w )
	{
		mdo.Text( sfc , str , x+1 , y+1 , h , w , RGB(0,0,0) )		 ;
		mdo.Text( sfc , str , x   , y   , h , w , RGB(255,255,255) ) ;	
	};
	static void BoxMoji( int sfc , LPCTSTR str , int x , int y , int h , int w , UINT c )
	{
		mdo.Text( sfc , str , x-1 , y   , h , w , RGB(0,0,0) ) ;
		mdo.Text( sfc , str , x+1 , y   , h , w , RGB(0,0,0) ) ;
		mdo.Text( sfc , str , x   , y-1 , h , w , RGB(0,0,0) ) ;
		mdo.Text( sfc , str , x   , y+1 , h , w , RGB(0,0,0) ) ;
		mdo.Text( sfc , str , x   , y   , h , w , c ) ;
	}

	static unsigned char *ROM( int iAddr ){ return pucRom+ ( ( ( (((unsigned int)(iAddr)>>16)&0xFF)*0x2000 | ((unsigned int)(iAddr)&0x1FFF)  )%(iPrgSize) ) + 0x10) ; }
	static void SetROM8 ( int iAddr , int iVal ){ ROM(iAddr)[0]=iVal; }
	static void SetROM16( int iAddr , int iVal ){ SetROM8(iAddr+0,iVal);SetROM8(iAddr+1,iVal>>8); }
	static void SetROM24( int iAddr , int iVal ){ SetROM16(iAddr+0,iVal);SetROM8(iAddr+2,iVal>>16); }
	static void SetROM32( int iAddr , unsigned int iVal ){ SetROM16(iAddr+0,iVal);SetROM16(iAddr+2,iVal>>16); }

	static int GetROM8 ( int iAddr ){ return ROM(iAddr)[0]; }
	static int GetROM16( int iAddr ){ return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8); }
	static int GetROM24( int iAddr ){ return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8)|(ROM(iAddr+2)[0]<<16); }
	static unsigned int GetROM32( int iAddr ){ return ROM(iAddr)[0]|(ROM(iAddr+1)[0]<<8)|(ROM(iAddr+2)[0]<<16)|((unsigned int)(ROM(iAddr+3)[0])<<24); }

	static int SafeRomLoad() ; //0: -1:qnlJȂ -2:G[Ń[U[f
	static void InitNameTable( LPTSTR *APdest ) ;
	static int LoadNameTable( LPTSTR *APdest , LPCTSTR filename ) ;
	static int LoadNameTable( tstring *pstrDest , int iSize , LPCTSTR filename ) ;

	static void SetupNESColor( LPCTSTR filename ) ;

	static void DropRoutine(WPARAM wp) ;

	static void LoadRoom( FODS *pFODS , int iRoom ) ;
	static tstring GetFODSFileName( int iRoom ) ;
	static int Compile() ;
//	static void DrawChipStatic( int iSFC , int iX , int iY , int iTileNo ) ;

private:
//[Jϐ
	static TASKHANDLE handle_frame_end ;
//[J֐
	static bool CheckFE() ;
	static void DebugOut( tofstream &oOS1 , tofstream &oOS2 , int iSenv , LPCTSTR str ) ;
};

#endif /*GLOBAL_CLASS_HEADER_INCLUDED*/

