#ifndef TASK_GUI0810_HEADER_INCLUDED
#define TASK_GUI0810_HEADER_INCLUDED

#include <windows.h>
#include <assert.h>
#include <tchar.h>

#ifdef TASK_GUI_CPP
#define TASK0810_NO_TASK_PRIORITY_HEADER_INCLUDE
#include "taskpriority.h"
#endif

#include "task0810.h"
#include "mydibobj3.h"
#include "TypedFunction.h"
using namespace std ;

class TaskObjectManager
{
public:
	static MyDIBObj3 *Pmdo ; //MDOIuWFNgւ̃|C^
	static void (*Prr)(void) ; //RequestRedraw֐ւ̃|C^
	static void RequestRedraw()
	{
		if( TaskObjectManager::Prr ) TaskObjectManager::Prr() ;
	}
};

class TaskObjectBoxText : public Task0810
{
public:
	TaskObjectBoxText( Task0810 *Pparent , bool handle_enabled , int x , int y , int h , int w , UINT col1 , UINT col2 , LPCTSTR str , int timer )
		: Task0810( Pparent , TP_BOX_TEXT , handle_enabled )
	{
		this->strText = str ;
		this->x = x ;
		this->y = y ;
		this->iW = w ;
		this->iH = h ;
		this->uiCol1 = col1 ;
		this->uiCol2 = col2 ;
		this->iTimer = timer ;
		this->InitFuncCalled() ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectBoxText() : Task0810() {;};
protected:
	void Finit() {;}
	void Fmain() ;
	void Fdest() {;}
	void Fdraw() ;

	tstring strText ;
	int iTimer ;
	int iW ;
	int iH ;
	UINT uiCol1 ;
	UINT uiCol2 ;
private:
} ;

class TaskObjectSubWindow : public Task0810
{
public:
	TaskObjectSubWindow( Task0810 *Pparent , bool handle_enabled , int x , int y , int w , int h , BMPD col = 0xFFFF )
		: Task0810( Pparent , TP_SUB_WINDOW , handle_enabled )
	{
		this->x = x ;
		this->y = y ;
		this->iW = w ;
		this->iH = h ;
		this->Col = col ;
		this->InitFuncCalled() ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectSubWindow() : Task0810() {;};
	int IsInWindow( int iX , int iY , int depth )
	{
		int tx , ty ;
		GetGlobalPosition( &tx , &ty , depth ) ;
		iX -= tx ;
		iY -= ty ;
		if( iX>=0 && iX<iW && iY>=0 && iY<iH )
			{ return 1 ;}
		return 0 ;
	}
protected:
	void Finit() ;
	void Fmain() ;
	void Fdest() {;}
	void Fdraw() ;

	int iW ;
	int iH ;
	int iClipX , iClipY , iClipW , iClipH ;
	UINT Col ;
private:
} ;

class TaskObjectBinaryEditor : public Task0810
{
public:
	TaskObjectBinaryEditor( Task0810 *Pparent , bool handle_enabled , int iX , int iY , int iFontSize , unsigned char *pData , int iMode , int iDataSize , int iDataPerLine=-1 )
		: Task0810( Pparent , TP_BINARY_EDITOR , handle_enabled )
	{
		this->x = iX ;
		this->y = iY ;
		this->iFontSize = iFontSize ;
		this->pData = pData ;
		this->iDataSize = iDataSize ;
		SetDataPerLine( iDataPerLine ) ;
		iWorkColumnWidth    = iFontSize/2 ;

		switch( iMode )
		{
		case 1:
			iWorkBytesPerNumber = 2 ;
			iWorkNumberSpan     = iWorkColumnWidth*(iWorkBytesPerNumber+1) ;
			ptcDrawFormat       = _T("%02X") ;
			pfuncGetValue         = GetValue ;
			pfuncModifyDataColumn = ModifyDataColumn ;
		break ;
		case 2:
			iWorkBytesPerNumber = 4 ;
			iWorkNumberSpan     = iWorkColumnWidth*(iWorkBytesPerNumber+1) ;
			ptcDrawFormat       = _T("%04X") ;
			pfuncGetValue         = GetValueW ;
			pfuncModifyDataColumn = ModifyDataColumnW ;
		break ;
		default:
			assert( 0 ) ;
		}

		this->InitFuncCalled() ;
		iSelectedPosition = -1 ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectBinaryEditor() : Task0810() {;};
	void SetDataPerLine( int iDataPerLine )
	{
		this->iDataPerLine = iDataPerLine ;
		if( iDataPerLine <= 0 )
		{
			this->iDataPerLine = 1 ;
		}
	}
	bool IsChanged()
	{
		int iTmp = iIsChanged ;
		iIsChanged = 0 ;
		return (iTmp!=0) ;
	}
protected:
	void Finit() ;
	void Fmain() ;
	void Fdest() ;
	void Fdraw() ;

	int iFontSize ;
	unsigned char *pData ;
	int iDataSize ;
	int iDataPerLine ;
	int iSelectedPosition ;
	int iIsChanged ;

	int iWorkColumnWidth ;
	int iWorkNumberSpan ;
	int iWorkBytesPerNumber ;
	_TCHAR *ptcDrawFormat ;

	int (*pfuncGetValue)( TaskObjectBinaryEditor* , int ) ;
	void (*pfuncModifyDataColumn)( TaskObjectBinaryEditor* , int ) ;

	static void ModifyDataColumn( TaskObjectBinaryEditor *pObj , int iNumber )
	{
unsigned char aucMask [2] = {0xF0,0x0F};
int iShift[2] = {4,0};
			pObj->pData[pObj->iSelectedPosition/2] &= ~aucMask       [pObj->iSelectedPosition%2] ;
			pObj->pData[pObj->iSelectedPosition/2] |= iNumber<<iShift[pObj->iSelectedPosition%2] ;
	}
	static int GetValue( TaskObjectBinaryEditor *pObj , int iOffset )
	{
		return pObj->pData[ iOffset ] ;
	}
	static void ModifyDataColumnW( TaskObjectBinaryEditor *pObj , int iNumber )
	{
		static const int aucMask[4] = {0xF000,0x0F00,0x00F0,0x000F,};
		static const int iShift[4]  = {12,8,4,0,};
		int iOffset = pObj->iSelectedPosition/pObj->iWorkBytesPerNumber ;
		int iTmp = GetValueW( pObj , iOffset )  ;
		iTmp &= ~aucMask       [pObj->iSelectedPosition%pObj->iWorkBytesPerNumber] ;
		iTmp |= iNumber<<iShift[pObj->iSelectedPosition%pObj->iWorkBytesPerNumber] ;
		pObj->pData[ iOffset*2+1 ] = (iTmp>>8) ;
		pObj->pData[ iOffset*2+0 ] = (iTmp&0xFF) ;
	}
	static int GetValueW( TaskObjectBinaryEditor *pObj , int iOffset )
	{
		return (pObj->pData[ iOffset*2+1 ]<<8) | pObj->pData[ iOffset*2 ] ;
	}
} ;


class TaskObjectCheckBox : public Task0810
{
public:
	TaskObjectCheckBox( Task0810 *Pparent , bool handle_enabled , int x , int y , int w , int h , tstring str , unsigned char *pucData )
		: Task0810( Pparent , TP_BOX_TEXT , handle_enabled )
	{
		this->strText = str ;
		this->x = x ;
		this->y = y ;
		this->iW = w ;
		this->iH = h ;
		this->pucData = pucData ;
		this->InitFuncCalled() ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectCheckBox() : Task0810() {;};
protected:
	void Finit() {;}
	void Fmain() ;
	void Fdest() {;}
	void Fdraw() ;

	tstring strText ;
	unsigned char *pucData ;
	int iW ;
	int iH ;
private:
} ;
class TaskObjectRotateList : public Task0810
{
public:
	TaskObjectRotateList( Task0810 *Pparent , bool handle_enabled , int x , int y , int iW , int iFontSize , int iRows , int *piData , tstring *pstrItem , int iMaxItem )
		: Task0810( Pparent , TP_BOX_TEXT , handle_enabled )
	{
		this->x = x ;
		this->y = y ;
		this->iW = iW ;
		this->iFontSize = iFontSize ;
		this->iRows = iRows ;
		this->piData = piData ;
		this->iMaxItem = iMaxItem ;
		this->iIsChanged = 0 ;
		this->iDragging = 0 ;
		this->pstrItem = NULL ;

		if( iMaxItem>=1 )
		{
			this->pstrItem = new tstring[ iMaxItem ] ;
			if( this->pstrItem )
			{
				for( int i=0 ; i<iMaxItem ; i++ )
				{
					this->pstrItem[i] = pstrItem[i] ;
				}
			}
		}
		this->InitFuncCalled() ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectRotateList() : Task0810(){;};
	bool IsChanged()
	{
		int iTmp = iIsChanged ;
		iIsChanged = 0 ;
		return (iTmp!=0) ;
	}
protected:
	void Finit() {;}
	void Fmain() ;
	void Fdest()
	{
		delete []pstrItem ;
	}
	void Fdraw() ;

	int iW ;
	int iFontSize ;
	int iRows ;
	int *piData ;
	tstring *pstrItem ;
	int iMaxItem ;
	int iIsChanged ;

	int iDragging ;
	int iDragPreX ;
	int iDragPreY ;
private:
} ;

class TaskObjectButton : public Task0810
{
public:
	TaskObjectButton( Task0810 *Pparent , bool handle_enabled , int x , int y , int iW , int iH , int iFontSize , tstring strCaption , void (*pFunc)( void * ) , void *pvArg )
		: Task0810( Pparent , TP_BUTTON , handle_enabled )
	{
		this->x = x ;
		this->y = y ;
		this->iW = iW ;
		this->iH = iH ;
		this->iFontSize = iFontSize ;
		this->strCaption = strCaption ;
		this->pFunc = pFunc ;
		this->pvArgument = pvArg ;

		iDragging = 0  ;
		this->InitFuncCalled() ;
		Finit();
		TaskObjectManager::RequestRedraw() ;
	}
	TaskObjectButton() : Task0810(){;};
protected:
	void Finit() ;
	void Fmain() ;
	void Fdest() ;
	void Fdraw() ;

	int iW ;
	int iH ;
	int iFontSize ;
	tstring strCaption ;
	void (*pFunc)( void* ) ;
	void *pvArgument ;

	int iDragging ;
private:
} ;

#endif /*TASK_GUI_HEADER_INCLUDED*/
